/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|*  * Sparc Disassembler                                                      *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#include "llvm/MC/MCInst.h"
#include "llvm/MC/MCSubtargetInfo.h"
#include "llvm/Support/DataTypes.h"
#include "llvm/Support/Debug.h"
#include "llvm/Support/LEB128.h"
#include "llvm/Support/raw_ostream.h"
#include "llvm/TargetParser/SubtargetFeature.h"
#include <assert.h>

namespace llvm {

// Helper functions for extracting fields from encoded instructions.
// InsnType must either be integral or an APInt-like object that must:
// * be default-constructible and copy-constructible
// * be constructible from an APInt (this can be private)
// * Support insertBits(bits, startBit, numBits)
// * Support extractBitsAsZExtValue(numBits, startBit)
// * Support the ~, &, ==, and != operators with other objects of the same type
// * Support the != and bitwise & with uint64_t
// * Support put (<<) to raw_ostream&
template <typename InsnType>
#if defined(_MSC_VER) && !defined(__clang__)
__declspec(noinline)
#endif
static std::enable_if_t<std::is_integral<InsnType>::value, InsnType>
fieldFromInstruction(const InsnType &insn, unsigned startBit,
                     unsigned numBits) {
  assert(startBit + numBits <= 64 && "Cannot support >64-bit extractions!");
  assert(startBit + numBits <= (sizeof(InsnType) * 8) &&
         "Instruction field out of bounds!");
  InsnType fieldMask;
  if (numBits == sizeof(InsnType) * 8)
    fieldMask = (InsnType)(-1LL);
  else
    fieldMask = (((InsnType)1 << numBits) - 1) << startBit;
  return (insn & fieldMask) >> startBit;
}

template <typename InsnType>
static std::enable_if_t<!std::is_integral<InsnType>::value, uint64_t>
fieldFromInstruction(const InsnType &insn, unsigned startBit,
                     unsigned numBits) {
  return insn.extractBitsAsZExtValue(numBits, startBit);
}

// Helper function for inserting bits extracted from an encoded instruction into
// a field.
template <typename InsnType>
static std::enable_if_t<std::is_integral<InsnType>::value>
insertBits(InsnType &field, InsnType bits, unsigned startBit, unsigned numBits) {
  assert(startBit + numBits <= sizeof field * 8);
  field |= (InsnType)bits << startBit;
}

template <typename InsnType>
static std::enable_if_t<!std::is_integral<InsnType>::value>
insertBits(InsnType &field, uint64_t bits, unsigned startBit, unsigned numBits) {
  field.insertBits(bits, startBit, numBits);
}

static bool Check(DecodeStatus &Out, DecodeStatus In) {
  Out = static_cast<DecodeStatus>(Out & In);
  return Out != MCDisassembler::Fail;
}

static const uint8_t DecoderTableSparc32[] = {
/* 0 */       MCD::OPC_ExtractField, 30, 2,  // Inst{31-30} ...
/* 3 */       MCD::OPC_FilterValue, 0, 183, 1, 0, // Skip to: 447
/* 8 */       MCD::OPC_ExtractField, 22, 3,  // Inst{24-22} ...
/* 11 */      MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 27
/* 16 */      MCD::OPC_CheckField, 25, 5, 0, 28, 29, 0, // Skip to: 7475
/* 23 */      MCD::OPC_Decode, 211, 5, 0, // Opcode: UNIMP
/* 27 */      MCD::OPC_FilterValue, 1, 127, 0, 0, // Skip to: 159
/* 32 */      MCD::OPC_ExtractField, 19, 3,  // Inst{21-19} ...
/* 35 */      MCD::OPC_FilterValue, 0, 31, 0, 0, // Skip to: 71
/* 40 */      MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 43 */      MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 57
/* 48 */      MCD::OPC_CheckPredicate, 0, 254, 28, 0, // Skip to: 7475
/* 53 */      MCD::OPC_Decode, 185, 2, 1, // Opcode: BPICCNT
/* 57 */      MCD::OPC_FilterValue, 1, 245, 28, 0, // Skip to: 7475
/* 62 */      MCD::OPC_CheckPredicate, 0, 240, 28, 0, // Skip to: 7475
/* 67 */      MCD::OPC_Decode, 184, 2, 1, // Opcode: BPICCANT
/* 71 */      MCD::OPC_FilterValue, 1, 31, 0, 0, // Skip to: 107
/* 76 */      MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 79 */      MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 93
/* 84 */      MCD::OPC_CheckPredicate, 0, 218, 28, 0, // Skip to: 7475
/* 89 */      MCD::OPC_Decode, 182, 2, 1, // Opcode: BPICC
/* 93 */      MCD::OPC_FilterValue, 1, 209, 28, 0, // Skip to: 7475
/* 98 */      MCD::OPC_CheckPredicate, 0, 204, 28, 0, // Skip to: 7475
/* 103 */     MCD::OPC_Decode, 183, 2, 1, // Opcode: BPICCA
/* 107 */     MCD::OPC_FilterValue, 4, 21, 0, 0, // Skip to: 133
/* 112 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 115 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 124
/* 120 */     MCD::OPC_Decode, 193, 2, 1, // Opcode: BPXCCNT
/* 124 */     MCD::OPC_FilterValue, 1, 178, 28, 0, // Skip to: 7475
/* 129 */     MCD::OPC_Decode, 192, 2, 1, // Opcode: BPXCCANT
/* 133 */     MCD::OPC_FilterValue, 5, 169, 28, 0, // Skip to: 7475
/* 138 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 141 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 150
/* 146 */     MCD::OPC_Decode, 190, 2, 1, // Opcode: BPXCC
/* 150 */     MCD::OPC_FilterValue, 1, 152, 28, 0, // Skip to: 7475
/* 155 */     MCD::OPC_Decode, 191, 2, 1, // Opcode: BPXCCA
/* 159 */     MCD::OPC_FilterValue, 2, 32, 0, 0, // Skip to: 196
/* 164 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 167 */     MCD::OPC_FilterValue, 0, 15, 0, 0, // Skip to: 187
/* 172 */     MCD::OPC_CheckField, 25, 4, 8, 4, 0, 0, // Skip to: 183
/* 179 */     MCD::OPC_Decode, 172, 2, 0, // Opcode: BA
/* 183 */     MCD::OPC_Decode, 173, 2, 2, // Opcode: BCOND
/* 187 */     MCD::OPC_FilterValue, 1, 115, 28, 0, // Skip to: 7475
/* 192 */     MCD::OPC_Decode, 174, 2, 2, // Opcode: BCONDA
/* 196 */     MCD::OPC_FilterValue, 3, 55, 0, 0, // Skip to: 256
/* 201 */     MCD::OPC_ExtractField, 19, 1,  // Inst{19} ...
/* 204 */     MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 230
/* 209 */     MCD::OPC_ExtractField, 28, 2,  // Inst{29-28} ...
/* 212 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 221
/* 217 */     MCD::OPC_Decode, 189, 2, 3, // Opcode: BPRNT
/* 221 */     MCD::OPC_FilterValue, 2, 81, 28, 0, // Skip to: 7475
/* 226 */     MCD::OPC_Decode, 188, 2, 3, // Opcode: BPRANT
/* 230 */     MCD::OPC_FilterValue, 1, 72, 28, 0, // Skip to: 7475
/* 235 */     MCD::OPC_ExtractField, 28, 2,  // Inst{29-28} ...
/* 238 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 247
/* 243 */     MCD::OPC_Decode, 186, 2, 3, // Opcode: BPR
/* 247 */     MCD::OPC_FilterValue, 2, 55, 28, 0, // Skip to: 7475
/* 252 */     MCD::OPC_Decode, 187, 2, 3, // Opcode: BPRA
/* 256 */     MCD::OPC_FilterValue, 4, 22, 0, 0, // Skip to: 283
/* 261 */     MCD::OPC_CheckField, 25, 5, 0, 11, 0, 0, // Skip to: 279
/* 268 */     MCD::OPC_CheckField, 0, 22, 0, 4, 0, 0, // Skip to: 279
/* 275 */     MCD::OPC_Decode, 189, 4, 4, // Opcode: NOP
/* 279 */     MCD::OPC_Decode, 229, 4, 5, // Opcode: SETHIi
/* 283 */     MCD::OPC_FilterValue, 5, 107, 0, 0, // Skip to: 395
/* 288 */     MCD::OPC_ExtractField, 19, 1,  // Inst{19} ...
/* 291 */     MCD::OPC_FilterValue, 0, 31, 0, 0, // Skip to: 327
/* 296 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 299 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 313
/* 304 */     MCD::OPC_CheckPredicate, 0, 254, 27, 0, // Skip to: 7475
/* 309 */     MCD::OPC_Decode, 181, 2, 6, // Opcode: BPFCCNT
/* 313 */     MCD::OPC_FilterValue, 1, 245, 27, 0, // Skip to: 7475
/* 318 */     MCD::OPC_CheckPredicate, 0, 240, 27, 0, // Skip to: 7475
/* 323 */     MCD::OPC_Decode, 180, 2, 6, // Opcode: BPFCCANT
/* 327 */     MCD::OPC_FilterValue, 1, 231, 27, 0, // Skip to: 7475
/* 332 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 335 */     MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 365
/* 340 */     MCD::OPC_CheckPredicate, 0, 11, 0, 0, // Skip to: 356
/* 345 */     MCD::OPC_CheckField, 20, 2, 0, 4, 0, 0, // Skip to: 356
/* 352 */     MCD::OPC_Decode, 237, 2, 1, // Opcode: FBCOND_V9
/* 356 */     MCD::OPC_CheckPredicate, 0, 202, 27, 0, // Skip to: 7475
/* 361 */     MCD::OPC_Decode, 178, 2, 6, // Opcode: BPFCC
/* 365 */     MCD::OPC_FilterValue, 1, 193, 27, 0, // Skip to: 7475
/* 370 */     MCD::OPC_CheckPredicate, 0, 11, 0, 0, // Skip to: 386
/* 375 */     MCD::OPC_CheckField, 20, 2, 0, 4, 0, 0, // Skip to: 386
/* 382 */     MCD::OPC_Decode, 236, 2, 1, // Opcode: FBCONDA_V9
/* 386 */     MCD::OPC_CheckPredicate, 0, 172, 27, 0, // Skip to: 7475
/* 391 */     MCD::OPC_Decode, 179, 2, 6, // Opcode: BPFCCA
/* 395 */     MCD::OPC_FilterValue, 6, 21, 0, 0, // Skip to: 421
/* 400 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 403 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 412
/* 408 */     MCD::OPC_Decode, 234, 2, 2, // Opcode: FBCOND
/* 412 */     MCD::OPC_FilterValue, 1, 146, 27, 0, // Skip to: 7475
/* 417 */     MCD::OPC_Decode, 235, 2, 2, // Opcode: FBCONDA
/* 421 */     MCD::OPC_FilterValue, 7, 137, 27, 0, // Skip to: 7475
/* 426 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 429 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 438
/* 434 */     MCD::OPC_Decode, 202, 2, 2, // Opcode: CBCOND
/* 438 */     MCD::OPC_FilterValue, 1, 120, 27, 0, // Skip to: 7475
/* 443 */     MCD::OPC_Decode, 203, 2, 2, // Opcode: CBCONDA
/* 447 */     MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 456
/* 452 */     MCD::OPC_Decode, 195, 2, 7, // Opcode: CALL
/* 456 */     MCD::OPC_FilterValue, 2, 91, 21, 0, // Skip to: 5928
/* 461 */     MCD::OPC_ExtractField, 19, 6,  // Inst{24-19} ...
/* 464 */     MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 497
/* 469 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 472 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 488
/* 477 */     MCD::OPC_CheckField, 5, 8, 0, 79, 27, 0, // Skip to: 7475
/* 484 */     MCD::OPC_Decode, 155, 2, 8, // Opcode: ADDrr
/* 488 */     MCD::OPC_FilterValue, 1, 70, 27, 0, // Skip to: 7475
/* 493 */     MCD::OPC_Decode, 154, 2, 9, // Opcode: ADDri
/* 497 */     MCD::OPC_FilterValue, 1, 28, 0, 0, // Skip to: 530
/* 502 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 505 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 521
/* 510 */     MCD::OPC_CheckField, 5, 8, 0, 46, 27, 0, // Skip to: 7475
/* 517 */     MCD::OPC_Decode, 168, 2, 8, // Opcode: ANDrr
/* 521 */     MCD::OPC_FilterValue, 1, 37, 27, 0, // Skip to: 7475
/* 526 */     MCD::OPC_Decode, 167, 2, 9, // Opcode: ANDri
/* 530 */     MCD::OPC_FilterValue, 2, 28, 0, 0, // Skip to: 563
/* 535 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 538 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 554
/* 543 */     MCD::OPC_CheckField, 5, 8, 0, 13, 27, 0, // Skip to: 7475
/* 550 */     MCD::OPC_Decode, 200, 4, 8, // Opcode: ORrr
/* 554 */     MCD::OPC_FilterValue, 1, 4, 27, 0, // Skip to: 7475
/* 559 */     MCD::OPC_Decode, 199, 4, 9, // Opcode: ORri
/* 563 */     MCD::OPC_FilterValue, 3, 28, 0, 0, // Skip to: 596
/* 568 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 571 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 587
/* 576 */     MCD::OPC_CheckField, 5, 8, 0, 236, 26, 0, // Skip to: 7475
/* 583 */     MCD::OPC_Decode, 245, 5, 8, // Opcode: XORrr
/* 587 */     MCD::OPC_FilterValue, 1, 227, 26, 0, // Skip to: 7475
/* 592 */     MCD::OPC_Decode, 244, 5, 9, // Opcode: XORri
/* 596 */     MCD::OPC_FilterValue, 4, 28, 0, 0, // Skip to: 629
/* 601 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 604 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 620
/* 609 */     MCD::OPC_CheckField, 5, 8, 0, 203, 26, 0, // Skip to: 7475
/* 616 */     MCD::OPC_Decode, 170, 5, 8, // Opcode: SUBrr
/* 620 */     MCD::OPC_FilterValue, 1, 194, 26, 0, // Skip to: 7475
/* 625 */     MCD::OPC_Decode, 169, 5, 9, // Opcode: SUBri
/* 629 */     MCD::OPC_FilterValue, 5, 28, 0, 0, // Skip to: 662
/* 634 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 637 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 653
/* 642 */     MCD::OPC_CheckField, 5, 8, 0, 170, 26, 0, // Skip to: 7475
/* 649 */     MCD::OPC_Decode, 163, 2, 8, // Opcode: ANDNrr
/* 653 */     MCD::OPC_FilterValue, 1, 161, 26, 0, // Skip to: 7475
/* 658 */     MCD::OPC_Decode, 162, 2, 9, // Opcode: ANDNri
/* 662 */     MCD::OPC_FilterValue, 6, 28, 0, 0, // Skip to: 695
/* 667 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 670 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 686
/* 675 */     MCD::OPC_CheckField, 5, 8, 0, 137, 26, 0, // Skip to: 7475
/* 682 */     MCD::OPC_Decode, 195, 4, 8, // Opcode: ORNrr
/* 686 */     MCD::OPC_FilterValue, 1, 128, 26, 0, // Skip to: 7475
/* 691 */     MCD::OPC_Decode, 194, 4, 9, // Opcode: ORNri
/* 695 */     MCD::OPC_FilterValue, 7, 28, 0, 0, // Skip to: 728
/* 700 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 703 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 719
/* 708 */     MCD::OPC_CheckField, 5, 8, 0, 104, 26, 0, // Skip to: 7475
/* 715 */     MCD::OPC_Decode, 239, 5, 8, // Opcode: XNORrr
/* 719 */     MCD::OPC_FilterValue, 1, 95, 26, 0, // Skip to: 7475
/* 724 */     MCD::OPC_Decode, 238, 5, 9, // Opcode: XNORri
/* 728 */     MCD::OPC_FilterValue, 8, 28, 0, 0, // Skip to: 761
/* 733 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 736 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 752
/* 741 */     MCD::OPC_CheckField, 5, 8, 0, 71, 26, 0, // Skip to: 7475
/* 748 */     MCD::OPC_Decode, 147, 2, 8, // Opcode: ADDCrr
/* 752 */     MCD::OPC_FilterValue, 1, 62, 26, 0, // Skip to: 7475
/* 757 */     MCD::OPC_Decode, 146, 2, 9, // Opcode: ADDCri
/* 761 */     MCD::OPC_FilterValue, 9, 28, 0, 0, // Skip to: 794
/* 766 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 769 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 785
/* 774 */     MCD::OPC_CheckField, 5, 8, 0, 38, 26, 0, // Skip to: 7475
/* 781 */     MCD::OPC_Decode, 188, 4, 10, // Opcode: MULXrr
/* 785 */     MCD::OPC_FilterValue, 1, 29, 26, 0, // Skip to: 7475
/* 790 */     MCD::OPC_Decode, 187, 4, 11, // Opcode: MULXri
/* 794 */     MCD::OPC_FilterValue, 10, 28, 0, 0, // Skip to: 827
/* 799 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 802 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 818
/* 807 */     MCD::OPC_CheckField, 5, 8, 0, 5, 26, 0, // Skip to: 7475
/* 814 */     MCD::OPC_Decode, 210, 5, 8, // Opcode: UMULrr
/* 818 */     MCD::OPC_FilterValue, 1, 252, 25, 0, // Skip to: 7475
/* 823 */     MCD::OPC_Decode, 209, 5, 9, // Opcode: UMULri
/* 827 */     MCD::OPC_FilterValue, 11, 28, 0, 0, // Skip to: 860
/* 832 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 835 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 851
/* 840 */     MCD::OPC_CheckField, 5, 8, 0, 228, 25, 0, // Skip to: 7475
/* 847 */     MCD::OPC_Decode, 242, 4, 8, // Opcode: SMULrr
/* 851 */     MCD::OPC_FilterValue, 1, 219, 25, 0, // Skip to: 7475
/* 856 */     MCD::OPC_Decode, 241, 4, 9, // Opcode: SMULri
/* 860 */     MCD::OPC_FilterValue, 12, 28, 0, 0, // Skip to: 893
/* 865 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 868 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 884
/* 873 */     MCD::OPC_CheckField, 5, 8, 0, 195, 25, 0, // Skip to: 7475
/* 880 */     MCD::OPC_Decode, 164, 5, 8, // Opcode: SUBCrr
/* 884 */     MCD::OPC_FilterValue, 1, 186, 25, 0, // Skip to: 7475
/* 889 */     MCD::OPC_Decode, 163, 5, 9, // Opcode: SUBCri
/* 893 */     MCD::OPC_FilterValue, 13, 28, 0, 0, // Skip to: 926
/* 898 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 901 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 917
/* 906 */     MCD::OPC_CheckField, 5, 8, 0, 162, 25, 0, // Skip to: 7475
/* 913 */     MCD::OPC_Decode, 201, 5, 10, // Opcode: UDIVXrr
/* 917 */     MCD::OPC_FilterValue, 1, 153, 25, 0, // Skip to: 7475
/* 922 */     MCD::OPC_Decode, 200, 5, 11, // Opcode: UDIVXri
/* 926 */     MCD::OPC_FilterValue, 14, 28, 0, 0, // Skip to: 959
/* 931 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 934 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 950
/* 939 */     MCD::OPC_CheckField, 5, 8, 0, 129, 25, 0, // Skip to: 7475
/* 946 */     MCD::OPC_Decode, 203, 5, 8, // Opcode: UDIVrr
/* 950 */     MCD::OPC_FilterValue, 1, 120, 25, 0, // Skip to: 7475
/* 955 */     MCD::OPC_Decode, 202, 5, 9, // Opcode: UDIVri
/* 959 */     MCD::OPC_FilterValue, 15, 28, 0, 0, // Skip to: 992
/* 964 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 967 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 983
/* 972 */     MCD::OPC_CheckField, 5, 8, 0, 96, 25, 0, // Skip to: 7475
/* 979 */     MCD::OPC_Decode, 227, 4, 8, // Opcode: SDIVrr
/* 983 */     MCD::OPC_FilterValue, 1, 87, 25, 0, // Skip to: 7475
/* 988 */     MCD::OPC_Decode, 226, 4, 9, // Opcode: SDIVri
/* 992 */     MCD::OPC_FilterValue, 16, 28, 0, 0, // Skip to: 1025
/* 997 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1000 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1016
/* 1005 */    MCD::OPC_CheckField, 5, 8, 0, 63, 25, 0, // Skip to: 7475
/* 1012 */    MCD::OPC_Decode, 145, 2, 8, // Opcode: ADDCCrr
/* 1016 */    MCD::OPC_FilterValue, 1, 54, 25, 0, // Skip to: 7475
/* 1021 */    MCD::OPC_Decode, 144, 2, 9, // Opcode: ADDCCri
/* 1025 */    MCD::OPC_FilterValue, 17, 28, 0, 0, // Skip to: 1058
/* 1030 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1033 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1049
/* 1038 */    MCD::OPC_CheckField, 5, 8, 0, 30, 25, 0, // Skip to: 7475
/* 1045 */    MCD::OPC_Decode, 159, 2, 8, // Opcode: ANDCCrr
/* 1049 */    MCD::OPC_FilterValue, 1, 21, 25, 0, // Skip to: 7475
/* 1054 */    MCD::OPC_Decode, 158, 2, 9, // Opcode: ANDCCri
/* 1058 */    MCD::OPC_FilterValue, 18, 28, 0, 0, // Skip to: 1091
/* 1063 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1066 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1082
/* 1071 */    MCD::OPC_CheckField, 5, 8, 0, 253, 24, 0, // Skip to: 7475
/* 1078 */    MCD::OPC_Decode, 191, 4, 8, // Opcode: ORCCrr
/* 1082 */    MCD::OPC_FilterValue, 1, 244, 24, 0, // Skip to: 7475
/* 1087 */    MCD::OPC_Decode, 190, 4, 9, // Opcode: ORCCri
/* 1091 */    MCD::OPC_FilterValue, 19, 28, 0, 0, // Skip to: 1124
/* 1096 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1099 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1115
/* 1104 */    MCD::OPC_CheckField, 5, 8, 0, 220, 24, 0, // Skip to: 7475
/* 1111 */    MCD::OPC_Decode, 241, 5, 8, // Opcode: XORCCrr
/* 1115 */    MCD::OPC_FilterValue, 1, 211, 24, 0, // Skip to: 7475
/* 1120 */    MCD::OPC_Decode, 240, 5, 9, // Opcode: XORCCri
/* 1124 */    MCD::OPC_FilterValue, 20, 51, 0, 0, // Skip to: 1180
/* 1129 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1132 */    MCD::OPC_FilterValue, 0, 23, 0, 0, // Skip to: 1160
/* 1137 */    MCD::OPC_ExtractField, 5, 8,  // Inst{12-5} ...
/* 1140 */    MCD::OPC_FilterValue, 0, 186, 24, 0, // Skip to: 7475
/* 1145 */    MCD::OPC_CheckField, 25, 5, 0, 4, 0, 0, // Skip to: 1156
/* 1152 */    MCD::OPC_Decode, 208, 2, 12, // Opcode: CMPrr
/* 1156 */    MCD::OPC_Decode, 162, 5, 8, // Opcode: SUBCCrr
/* 1160 */    MCD::OPC_FilterValue, 1, 166, 24, 0, // Skip to: 7475
/* 1165 */    MCD::OPC_CheckField, 25, 5, 0, 4, 0, 0, // Skip to: 1176
/* 1172 */    MCD::OPC_Decode, 207, 2, 13, // Opcode: CMPri
/* 1176 */    MCD::OPC_Decode, 161, 5, 9, // Opcode: SUBCCri
/* 1180 */    MCD::OPC_FilterValue, 21, 28, 0, 0, // Skip to: 1213
/* 1185 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1188 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1204
/* 1193 */    MCD::OPC_CheckField, 5, 8, 0, 131, 24, 0, // Skip to: 7475
/* 1200 */    MCD::OPC_Decode, 161, 2, 8, // Opcode: ANDNCCrr
/* 1204 */    MCD::OPC_FilterValue, 1, 122, 24, 0, // Skip to: 7475
/* 1209 */    MCD::OPC_Decode, 160, 2, 9, // Opcode: ANDNCCri
/* 1213 */    MCD::OPC_FilterValue, 22, 28, 0, 0, // Skip to: 1246
/* 1218 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1221 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1237
/* 1226 */    MCD::OPC_CheckField, 5, 8, 0, 98, 24, 0, // Skip to: 7475
/* 1233 */    MCD::OPC_Decode, 193, 4, 8, // Opcode: ORNCCrr
/* 1237 */    MCD::OPC_FilterValue, 1, 89, 24, 0, // Skip to: 7475
/* 1242 */    MCD::OPC_Decode, 192, 4, 9, // Opcode: ORNCCri
/* 1246 */    MCD::OPC_FilterValue, 23, 28, 0, 0, // Skip to: 1279
/* 1251 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1254 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1270
/* 1259 */    MCD::OPC_CheckField, 5, 8, 0, 65, 24, 0, // Skip to: 7475
/* 1266 */    MCD::OPC_Decode, 236, 5, 8, // Opcode: XNORCCrr
/* 1270 */    MCD::OPC_FilterValue, 1, 56, 24, 0, // Skip to: 7475
/* 1275 */    MCD::OPC_Decode, 235, 5, 9, // Opcode: XNORCCri
/* 1279 */    MCD::OPC_FilterValue, 24, 28, 0, 0, // Skip to: 1312
/* 1284 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1287 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1303
/* 1292 */    MCD::OPC_CheckField, 5, 8, 0, 32, 24, 0, // Skip to: 7475
/* 1299 */    MCD::OPC_Decode, 149, 2, 8, // Opcode: ADDErr
/* 1303 */    MCD::OPC_FilterValue, 1, 23, 24, 0, // Skip to: 7475
/* 1308 */    MCD::OPC_Decode, 148, 2, 9, // Opcode: ADDEri
/* 1312 */    MCD::OPC_FilterValue, 26, 28, 0, 0, // Skip to: 1345
/* 1317 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1320 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1336
/* 1325 */    MCD::OPC_CheckField, 5, 8, 0, 255, 23, 0, // Skip to: 7475
/* 1332 */    MCD::OPC_Decode, 207, 5, 8, // Opcode: UMULCCrr
/* 1336 */    MCD::OPC_FilterValue, 1, 246, 23, 0, // Skip to: 7475
/* 1341 */    MCD::OPC_Decode, 206, 5, 9, // Opcode: UMULCCri
/* 1345 */    MCD::OPC_FilterValue, 27, 28, 0, 0, // Skip to: 1378
/* 1350 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1353 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1369
/* 1358 */    MCD::OPC_CheckField, 5, 8, 0, 222, 23, 0, // Skip to: 7475
/* 1365 */    MCD::OPC_Decode, 240, 4, 8, // Opcode: SMULCCrr
/* 1369 */    MCD::OPC_FilterValue, 1, 213, 23, 0, // Skip to: 7475
/* 1374 */    MCD::OPC_Decode, 239, 4, 9, // Opcode: SMULCCri
/* 1378 */    MCD::OPC_FilterValue, 28, 28, 0, 0, // Skip to: 1411
/* 1383 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1386 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1402
/* 1391 */    MCD::OPC_CheckField, 5, 8, 0, 189, 23, 0, // Skip to: 7475
/* 1398 */    MCD::OPC_Decode, 166, 5, 8, // Opcode: SUBErr
/* 1402 */    MCD::OPC_FilterValue, 1, 180, 23, 0, // Skip to: 7475
/* 1407 */    MCD::OPC_Decode, 165, 5, 9, // Opcode: SUBEri
/* 1411 */    MCD::OPC_FilterValue, 30, 28, 0, 0, // Skip to: 1444
/* 1416 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1419 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1435
/* 1424 */    MCD::OPC_CheckField, 5, 8, 0, 156, 23, 0, // Skip to: 7475
/* 1431 */    MCD::OPC_Decode, 199, 5, 8, // Opcode: UDIVCCrr
/* 1435 */    MCD::OPC_FilterValue, 1, 147, 23, 0, // Skip to: 7475
/* 1440 */    MCD::OPC_Decode, 198, 5, 9, // Opcode: UDIVCCri
/* 1444 */    MCD::OPC_FilterValue, 31, 28, 0, 0, // Skip to: 1477
/* 1449 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1452 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1468
/* 1457 */    MCD::OPC_CheckField, 5, 8, 0, 123, 23, 0, // Skip to: 7475
/* 1464 */    MCD::OPC_Decode, 223, 4, 8, // Opcode: SDIVCCrr
/* 1468 */    MCD::OPC_FilterValue, 1, 114, 23, 0, // Skip to: 7475
/* 1473 */    MCD::OPC_Decode, 222, 4, 9, // Opcode: SDIVCCri
/* 1477 */    MCD::OPC_FilterValue, 32, 28, 0, 0, // Skip to: 1510
/* 1482 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1485 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1501
/* 1490 */    MCD::OPC_CheckField, 5, 8, 0, 90, 23, 0, // Skip to: 7475
/* 1497 */    MCD::OPC_Decode, 180, 5, 8, // Opcode: TADDCCrr
/* 1501 */    MCD::OPC_FilterValue, 1, 81, 23, 0, // Skip to: 7475
/* 1506 */    MCD::OPC_Decode, 179, 5, 9, // Opcode: TADDCCri
/* 1510 */    MCD::OPC_FilterValue, 33, 28, 0, 0, // Skip to: 1543
/* 1515 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1518 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1534
/* 1523 */    MCD::OPC_CheckField, 5, 8, 0, 57, 23, 0, // Skip to: 7475
/* 1530 */    MCD::OPC_Decode, 195, 5, 8, // Opcode: TSUBCCrr
/* 1534 */    MCD::OPC_FilterValue, 1, 48, 23, 0, // Skip to: 7475
/* 1539 */    MCD::OPC_Decode, 194, 5, 9, // Opcode: TSUBCCri
/* 1543 */    MCD::OPC_FilterValue, 34, 28, 0, 0, // Skip to: 1576
/* 1548 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1551 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1567
/* 1556 */    MCD::OPC_CheckField, 5, 8, 0, 24, 23, 0, // Skip to: 7475
/* 1563 */    MCD::OPC_Decode, 178, 5, 8, // Opcode: TADDCCTVrr
/* 1567 */    MCD::OPC_FilterValue, 1, 15, 23, 0, // Skip to: 7475
/* 1572 */    MCD::OPC_Decode, 177, 5, 9, // Opcode: TADDCCTVri
/* 1576 */    MCD::OPC_FilterValue, 35, 28, 0, 0, // Skip to: 1609
/* 1581 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1584 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1600
/* 1589 */    MCD::OPC_CheckField, 5, 8, 0, 247, 22, 0, // Skip to: 7475
/* 1596 */    MCD::OPC_Decode, 193, 5, 8, // Opcode: TSUBCCTVrr
/* 1600 */    MCD::OPC_FilterValue, 1, 238, 22, 0, // Skip to: 7475
/* 1605 */    MCD::OPC_Decode, 192, 5, 9, // Opcode: TSUBCCTVri
/* 1609 */    MCD::OPC_FilterValue, 36, 28, 0, 0, // Skip to: 1642
/* 1614 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1617 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1633
/* 1622 */    MCD::OPC_CheckField, 5, 8, 0, 214, 22, 0, // Skip to: 7475
/* 1629 */    MCD::OPC_Decode, 186, 4, 8, // Opcode: MULSCCrr
/* 1633 */    MCD::OPC_FilterValue, 1, 205, 22, 0, // Skip to: 7475
/* 1638 */    MCD::OPC_Decode, 185, 4, 9, // Opcode: MULSCCri
/* 1642 */    MCD::OPC_FilterValue, 37, 39, 0, 0, // Skip to: 1686
/* 1647 */    MCD::OPC_ExtractField, 12, 2,  // Inst{13-12} ...
/* 1650 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 1659
/* 1655 */    MCD::OPC_Decode, 236, 4, 8, // Opcode: SLLrr
/* 1659 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1668
/* 1664 */    MCD::OPC_Decode, 234, 4, 14, // Opcode: SLLXrr
/* 1668 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1677
/* 1673 */    MCD::OPC_Decode, 235, 4, 15, // Opcode: SLLri
/* 1677 */    MCD::OPC_FilterValue, 3, 161, 22, 0, // Skip to: 7475
/* 1682 */    MCD::OPC_Decode, 233, 4, 16, // Opcode: SLLXri
/* 1686 */    MCD::OPC_FilterValue, 38, 39, 0, 0, // Skip to: 1730
/* 1691 */    MCD::OPC_ExtractField, 12, 2,  // Inst{13-12} ...
/* 1694 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 1703
/* 1699 */    MCD::OPC_Decode, 250, 4, 8, // Opcode: SRLrr
/* 1703 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1712
/* 1708 */    MCD::OPC_Decode, 248, 4, 14, // Opcode: SRLXrr
/* 1712 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1721
/* 1717 */    MCD::OPC_Decode, 249, 4, 15, // Opcode: SRLri
/* 1721 */    MCD::OPC_FilterValue, 3, 117, 22, 0, // Skip to: 7475
/* 1726 */    MCD::OPC_Decode, 247, 4, 16, // Opcode: SRLXri
/* 1730 */    MCD::OPC_FilterValue, 39, 39, 0, 0, // Skip to: 1774
/* 1735 */    MCD::OPC_ExtractField, 12, 2,  // Inst{13-12} ...
/* 1738 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 1747
/* 1743 */    MCD::OPC_Decode, 246, 4, 8, // Opcode: SRArr
/* 1747 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1756
/* 1752 */    MCD::OPC_Decode, 244, 4, 14, // Opcode: SRAXrr
/* 1756 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1765
/* 1761 */    MCD::OPC_Decode, 245, 4, 15, // Opcode: SRAri
/* 1765 */    MCD::OPC_FilterValue, 3, 73, 22, 0, // Skip to: 7475
/* 1770 */    MCD::OPC_Decode, 243, 4, 16, // Opcode: SRAXri
/* 1774 */    MCD::OPC_FilterValue, 40, 81, 0, 0, // Skip to: 1860
/* 1779 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1782 */    MCD::OPC_FilterValue, 0, 45, 0, 0, // Skip to: 1832
/* 1787 */    MCD::OPC_ExtractField, 0, 13,  // Inst{12-0} ...
/* 1790 */    MCD::OPC_FilterValue, 0, 48, 22, 0, // Skip to: 7475
/* 1795 */    MCD::OPC_ExtractField, 14, 5,  // Inst{18-14} ...
/* 1798 */    MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 1812
/* 1803 */    MCD::OPC_CheckPredicate, 0, 20, 0, 0, // Skip to: 1828
/* 1808 */    MCD::OPC_Decode, 209, 4, 17, // Opcode: RDPC
/* 1812 */    MCD::OPC_FilterValue, 15, 11, 0, 0, // Skip to: 1828
/* 1817 */    MCD::OPC_CheckField, 25, 5, 0, 4, 0, 0, // Skip to: 1828
/* 1824 */    MCD::OPC_Decode, 252, 4, 4, // Opcode: STBAR
/* 1828 */    MCD::OPC_Decode, 208, 4, 18, // Opcode: RDASR
/* 1832 */    MCD::OPC_FilterValue, 1, 6, 22, 0, // Skip to: 7475
/* 1837 */    MCD::OPC_CheckPredicate, 0, 1, 22, 0, // Skip to: 7475
/* 1842 */    MCD::OPC_CheckField, 25, 5, 0, 250, 21, 0, // Skip to: 7475
/* 1849 */    MCD::OPC_CheckField, 14, 5, 15, 243, 21, 0, // Skip to: 7475
/* 1856 */    MCD::OPC_Decode, 171, 4, 19, // Opcode: MEMBARi
/* 1860 */    MCD::OPC_FilterValue, 41, 11, 0, 0, // Skip to: 1876
/* 1865 */    MCD::OPC_CheckField, 0, 19, 0, 227, 21, 0, // Skip to: 7475
/* 1872 */    MCD::OPC_Decode, 211, 4, 17, // Opcode: RDPSR
/* 1876 */    MCD::OPC_FilterValue, 42, 28, 0, 0, // Skip to: 1909
/* 1881 */    MCD::OPC_ExtractField, 0, 14,  // Inst{13-0} ...
/* 1884 */    MCD::OPC_FilterValue, 0, 210, 21, 0, // Skip to: 7475
/* 1889 */    MCD::OPC_CheckField, 14, 5, 0, 4, 0, 0, // Skip to: 1900
/* 1896 */    MCD::OPC_Decode, 213, 4, 17, // Opcode: RDWIM
/* 1900 */    MCD::OPC_CheckPredicate, 0, 194, 21, 0, // Skip to: 7475
/* 1905 */    MCD::OPC_Decode, 210, 4, 20, // Opcode: RDPR
/* 1909 */    MCD::OPC_FilterValue, 43, 28, 0, 0, // Skip to: 1942
/* 1914 */    MCD::OPC_ExtractField, 0, 19,  // Inst{18-0} ...
/* 1917 */    MCD::OPC_FilterValue, 0, 177, 21, 0, // Skip to: 7475
/* 1922 */    MCD::OPC_CheckPredicate, 0, 11, 0, 0, // Skip to: 1938
/* 1927 */    MCD::OPC_CheckField, 25, 5, 0, 4, 0, 0, // Skip to: 1938
/* 1934 */    MCD::OPC_Decode, 144, 3, 4, // Opcode: FLUSHW
/* 1938 */    MCD::OPC_Decode, 212, 4, 17, // Opcode: RDTBR
/* 1942 */    MCD::OPC_FilterValue, 44, 141, 0, 0, // Skip to: 2088
/* 1947 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1950 */    MCD::OPC_FilterValue, 0, 64, 0, 0, // Skip to: 2019
/* 1955 */    MCD::OPC_ExtractField, 18, 1,  // Inst{18} ...
/* 1958 */    MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 1988
/* 1963 */    MCD::OPC_CheckPredicate, 0, 11, 0, 0, // Skip to: 1979
/* 1968 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, 0, // Skip to: 1979
/* 1975 */    MCD::OPC_Decode, 174, 4, 21, // Opcode: MOVFCCrr
/* 1979 */    MCD::OPC_CheckPredicate, 0, 115, 21, 0, // Skip to: 7475
/* 1984 */    MCD::OPC_Decode, 222, 5, 22, // Opcode: V9MOVFCCrr
/* 1988 */    MCD::OPC_FilterValue, 1, 106, 21, 0, // Skip to: 7475
/* 1993 */    MCD::OPC_ExtractField, 11, 2,  // Inst{12-11} ...
/* 1996 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 2010
/* 2001 */    MCD::OPC_CheckPredicate, 0, 93, 21, 0, // Skip to: 7475
/* 2006 */    MCD::OPC_Decode, 176, 4, 21, // Opcode: MOVICCrr
/* 2010 */    MCD::OPC_FilterValue, 2, 84, 21, 0, // Skip to: 7475
/* 2015 */    MCD::OPC_Decode, 183, 4, 21, // Opcode: MOVXCCrr
/* 2019 */    MCD::OPC_FilterValue, 1, 75, 21, 0, // Skip to: 7475
/* 2024 */    MCD::OPC_ExtractField, 18, 1,  // Inst{18} ...
/* 2027 */    MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 2057
/* 2032 */    MCD::OPC_CheckPredicate, 0, 11, 0, 0, // Skip to: 2048
/* 2037 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, 0, // Skip to: 2048
/* 2044 */    MCD::OPC_Decode, 173, 4, 23, // Opcode: MOVFCCri
/* 2048 */    MCD::OPC_CheckPredicate, 0, 46, 21, 0, // Skip to: 7475
/* 2053 */    MCD::OPC_Decode, 221, 5, 24, // Opcode: V9MOVFCCri
/* 2057 */    MCD::OPC_FilterValue, 1, 37, 21, 0, // Skip to: 7475
/* 2062 */    MCD::OPC_ExtractField, 11, 2,  // Inst{12-11} ...
/* 2065 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 2079
/* 2070 */    MCD::OPC_CheckPredicate, 0, 24, 21, 0, // Skip to: 7475
/* 2075 */    MCD::OPC_Decode, 175, 4, 23, // Opcode: MOVICCri
/* 2079 */    MCD::OPC_FilterValue, 2, 15, 21, 0, // Skip to: 7475
/* 2084 */    MCD::OPC_Decode, 182, 4, 23, // Opcode: MOVXCCri
/* 2088 */    MCD::OPC_FilterValue, 45, 28, 0, 0, // Skip to: 2121
/* 2093 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 2096 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 2112
/* 2101 */    MCD::OPC_CheckField, 5, 8, 0, 247, 20, 0, // Skip to: 7475
/* 2108 */    MCD::OPC_Decode, 225, 4, 10, // Opcode: SDIVXrr
/* 2112 */    MCD::OPC_FilterValue, 1, 238, 20, 0, // Skip to: 7475
/* 2117 */    MCD::OPC_Decode, 224, 4, 11, // Opcode: SDIVXri
/* 2121 */    MCD::OPC_FilterValue, 46, 16, 0, 0, // Skip to: 2142
/* 2126 */    MCD::OPC_CheckPredicate, 0, 224, 20, 0, // Skip to: 7475
/* 2131 */    MCD::OPC_CheckField, 5, 14, 0, 217, 20, 0, // Skip to: 7475
/* 2138 */    MCD::OPC_Decode, 203, 4, 25, // Opcode: POPCrr
/* 2142 */    MCD::OPC_FilterValue, 47, 28, 0, 0, // Skip to: 2175
/* 2147 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 2150 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 2166
/* 2155 */    MCD::OPC_CheckField, 5, 5, 0, 193, 20, 0, // Skip to: 7475
/* 2162 */    MCD::OPC_Decode, 178, 4, 26, // Opcode: MOVRrr
/* 2166 */    MCD::OPC_FilterValue, 1, 184, 20, 0, // Skip to: 7475
/* 2171 */    MCD::OPC_Decode, 177, 4, 27, // Opcode: MOVRri
/* 2175 */    MCD::OPC_FilterValue, 48, 51, 0, 0, // Skip to: 2231
/* 2180 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 2183 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 2199
/* 2188 */    MCD::OPC_CheckField, 5, 8, 0, 160, 20, 0, // Skip to: 7475
/* 2195 */    MCD::OPC_Decode, 224, 5, 28, // Opcode: WRASRrr
/* 2199 */    MCD::OPC_FilterValue, 1, 151, 20, 0, // Skip to: 7475
/* 2204 */    MCD::OPC_CheckPredicate, 0, 18, 0, 0, // Skip to: 2227
/* 2209 */    MCD::OPC_CheckField, 25, 5, 15, 11, 0, 0, // Skip to: 2227
/* 2216 */    MCD::OPC_CheckField, 14, 5, 0, 4, 0, 0, // Skip to: 2227
/* 2223 */    MCD::OPC_Decode, 232, 4, 29, // Opcode: SIR
/* 2227 */    MCD::OPC_Decode, 223, 5, 30, // Opcode: WRASRri
/* 2231 */    MCD::OPC_FilterValue, 49, 79, 0, 0, // Skip to: 2315
/* 2236 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 2239 */    MCD::OPC_FilterValue, 0, 40, 0, 0, // Skip to: 2284
/* 2244 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 2247 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 2263
/* 2252 */    MCD::OPC_CheckField, 5, 8, 0, 96, 20, 0, // Skip to: 7475
/* 2259 */    MCD::OPC_Decode, 228, 5, 12, // Opcode: WRPSRrr
/* 2263 */    MCD::OPC_FilterValue, 1, 87, 20, 0, // Skip to: 7475
/* 2268 */    MCD::OPC_CheckPredicate, 1, 82, 20, 0, // Skip to: 7475
/* 2273 */    MCD::OPC_CheckField, 5, 8, 0, 75, 20, 0, // Skip to: 7475
/* 2280 */    MCD::OPC_Decode, 207, 4, 12, // Opcode: PWRPSRrr
/* 2284 */    MCD::OPC_FilterValue, 1, 66, 20, 0, // Skip to: 7475
/* 2289 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 2292 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2301
/* 2297 */    MCD::OPC_Decode, 227, 5, 13, // Opcode: WRPSRri
/* 2301 */    MCD::OPC_FilterValue, 1, 49, 20, 0, // Skip to: 7475
/* 2306 */    MCD::OPC_CheckPredicate, 1, 44, 20, 0, // Skip to: 7475
/* 2311 */    MCD::OPC_Decode, 206, 4, 13, // Opcode: PWRPSRri
/* 2315 */    MCD::OPC_FilterValue, 50, 61, 0, 0, // Skip to: 2381
/* 2320 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 2323 */    MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 2356
/* 2328 */    MCD::OPC_ExtractField, 5, 8,  // Inst{12-5} ...
/* 2331 */    MCD::OPC_FilterValue, 0, 19, 20, 0, // Skip to: 7475
/* 2336 */    MCD::OPC_CheckField, 25, 5, 0, 4, 0, 0, // Skip to: 2347
/* 2343 */    MCD::OPC_Decode, 232, 5, 12, // Opcode: WRWIMrr
/* 2347 */    MCD::OPC_CheckPredicate, 0, 3, 20, 0, // Skip to: 7475
/* 2352 */    MCD::OPC_Decode, 226, 5, 31, // Opcode: WRPRrr
/* 2356 */    MCD::OPC_FilterValue, 1, 250, 19, 0, // Skip to: 7475
/* 2361 */    MCD::OPC_CheckField, 25, 5, 0, 4, 0, 0, // Skip to: 2372
/* 2368 */    MCD::OPC_Decode, 231, 5, 13, // Opcode: WRWIMri
/* 2372 */    MCD::OPC_CheckPredicate, 0, 234, 19, 0, // Skip to: 7475
/* 2377 */    MCD::OPC_Decode, 225, 5, 32, // Opcode: WRPRri
/* 2381 */    MCD::OPC_FilterValue, 51, 42, 0, 0, // Skip to: 2428
/* 2386 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 2389 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 2412
/* 2394 */    MCD::OPC_CheckField, 25, 5, 0, 210, 19, 0, // Skip to: 7475
/* 2401 */    MCD::OPC_CheckField, 5, 8, 0, 203, 19, 0, // Skip to: 7475
/* 2408 */    MCD::OPC_Decode, 230, 5, 12, // Opcode: WRTBRrr
/* 2412 */    MCD::OPC_FilterValue, 1, 194, 19, 0, // Skip to: 7475
/* 2417 */    MCD::OPC_CheckField, 25, 5, 0, 187, 19, 0, // Skip to: 7475
/* 2424 */    MCD::OPC_Decode, 229, 5, 13, // Opcode: WRTBRri
/* 2428 */    MCD::OPC_FilterValue, 52, 43, 3, 0, // Skip to: 3244
/* 2433 */    MCD::OPC_ExtractField, 5, 9,  // Inst{13-5} ...
/* 2436 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 2452
/* 2441 */    MCD::OPC_CheckField, 14, 5, 0, 163, 19, 0, // Skip to: 7475
/* 2448 */    MCD::OPC_Decode, 159, 3, 33, // Opcode: FMOVS
/* 2452 */    MCD::OPC_FilterValue, 2, 16, 0, 0, // Skip to: 2473
/* 2457 */    MCD::OPC_CheckPredicate, 0, 149, 19, 0, // Skip to: 7475
/* 2462 */    MCD::OPC_CheckField, 14, 5, 0, 142, 19, 0, // Skip to: 7475
/* 2469 */    MCD::OPC_Decode, 148, 3, 34, // Opcode: FMOVD
/* 2473 */    MCD::OPC_FilterValue, 3, 16, 0, 0, // Skip to: 2494
/* 2478 */    MCD::OPC_CheckPredicate, 0, 128, 19, 0, // Skip to: 7475
/* 2483 */    MCD::OPC_CheckField, 14, 5, 0, 121, 19, 0, // Skip to: 7475
/* 2490 */    MCD::OPC_Decode, 152, 3, 35, // Opcode: FMOVQ
/* 2494 */    MCD::OPC_FilterValue, 5, 11, 0, 0, // Skip to: 2510
/* 2499 */    MCD::OPC_CheckField, 14, 5, 0, 105, 19, 0, // Skip to: 7475
/* 2506 */    MCD::OPC_Decode, 179, 3, 33, // Opcode: FNEGS
/* 2510 */    MCD::OPC_FilterValue, 6, 16, 0, 0, // Skip to: 2531
/* 2515 */    MCD::OPC_CheckPredicate, 0, 91, 19, 0, // Skip to: 7475
/* 2520 */    MCD::OPC_CheckField, 14, 5, 0, 84, 19, 0, // Skip to: 7475
/* 2527 */    MCD::OPC_Decode, 177, 3, 34, // Opcode: FNEGD
/* 2531 */    MCD::OPC_FilterValue, 7, 16, 0, 0, // Skip to: 2552
/* 2536 */    MCD::OPC_CheckPredicate, 0, 70, 19, 0, // Skip to: 7475
/* 2541 */    MCD::OPC_CheckField, 14, 5, 0, 63, 19, 0, // Skip to: 7475
/* 2548 */    MCD::OPC_Decode, 178, 3, 35, // Opcode: FNEGQ
/* 2552 */    MCD::OPC_FilterValue, 9, 11, 0, 0, // Skip to: 2568
/* 2557 */    MCD::OPC_CheckField, 14, 5, 0, 47, 19, 0, // Skip to: 7475
/* 2564 */    MCD::OPC_Decode, 223, 2, 33, // Opcode: FABSS
/* 2568 */    MCD::OPC_FilterValue, 10, 16, 0, 0, // Skip to: 2589
/* 2573 */    MCD::OPC_CheckPredicate, 0, 33, 19, 0, // Skip to: 7475
/* 2578 */    MCD::OPC_CheckField, 14, 5, 0, 26, 19, 0, // Skip to: 7475
/* 2585 */    MCD::OPC_Decode, 221, 2, 34, // Opcode: FABSD
/* 2589 */    MCD::OPC_FilterValue, 11, 16, 0, 0, // Skip to: 2610
/* 2594 */    MCD::OPC_CheckPredicate, 0, 12, 19, 0, // Skip to: 7475
/* 2599 */    MCD::OPC_CheckField, 14, 5, 0, 5, 19, 0, // Skip to: 7475
/* 2606 */    MCD::OPC_Decode, 222, 2, 35, // Opcode: FABSQ
/* 2610 */    MCD::OPC_FilterValue, 41, 11, 0, 0, // Skip to: 2626
/* 2615 */    MCD::OPC_CheckField, 14, 5, 0, 245, 18, 0, // Skip to: 7475
/* 2622 */    MCD::OPC_Decode, 223, 3, 33, // Opcode: FSQRTS
/* 2626 */    MCD::OPC_FilterValue, 42, 11, 0, 0, // Skip to: 2642
/* 2631 */    MCD::OPC_CheckField, 14, 5, 0, 229, 18, 0, // Skip to: 7475
/* 2638 */    MCD::OPC_Decode, 221, 3, 34, // Opcode: FSQRTD
/* 2642 */    MCD::OPC_FilterValue, 43, 11, 0, 0, // Skip to: 2658
/* 2647 */    MCD::OPC_CheckField, 14, 5, 0, 213, 18, 0, // Skip to: 7475
/* 2654 */    MCD::OPC_Decode, 222, 3, 35, // Opcode: FSQRTQ
/* 2658 */    MCD::OPC_FilterValue, 65, 4, 0, 0, // Skip to: 2667
/* 2663 */    MCD::OPC_Decode, 226, 2, 36, // Opcode: FADDS
/* 2667 */    MCD::OPC_FilterValue, 66, 4, 0, 0, // Skip to: 2676
/* 2672 */    MCD::OPC_Decode, 224, 2, 37, // Opcode: FADDD
/* 2676 */    MCD::OPC_FilterValue, 67, 4, 0, 0, // Skip to: 2685
/* 2681 */    MCD::OPC_Decode, 225, 2, 38, // Opcode: FADDQ
/* 2685 */    MCD::OPC_FilterValue, 69, 4, 0, 0, // Skip to: 2694
/* 2690 */    MCD::OPC_Decode, 238, 3, 36, // Opcode: FSUBS
/* 2694 */    MCD::OPC_FilterValue, 70, 4, 0, 0, // Skip to: 2703
/* 2699 */    MCD::OPC_Decode, 236, 3, 37, // Opcode: FSUBD
/* 2703 */    MCD::OPC_FilterValue, 71, 4, 0, 0, // Skip to: 2712
/* 2708 */    MCD::OPC_Decode, 237, 3, 38, // Opcode: FSUBQ
/* 2712 */    MCD::OPC_FilterValue, 73, 4, 0, 0, // Skip to: 2721
/* 2717 */    MCD::OPC_Decode, 172, 3, 36, // Opcode: FMULS
/* 2721 */    MCD::OPC_FilterValue, 74, 4, 0, 0, // Skip to: 2730
/* 2726 */    MCD::OPC_Decode, 168, 3, 37, // Opcode: FMULD
/* 2730 */    MCD::OPC_FilterValue, 75, 4, 0, 0, // Skip to: 2739
/* 2735 */    MCD::OPC_Decode, 171, 3, 38, // Opcode: FMULQ
/* 2739 */    MCD::OPC_FilterValue, 77, 4, 0, 0, // Skip to: 2748
/* 2744 */    MCD::OPC_Decode, 255, 2, 36, // Opcode: FDIVS
/* 2748 */    MCD::OPC_FilterValue, 78, 4, 0, 0, // Skip to: 2757
/* 2753 */    MCD::OPC_Decode, 253, 2, 37, // Opcode: FDIVD
/* 2757 */    MCD::OPC_FilterValue, 79, 4, 0, 0, // Skip to: 2766
/* 2762 */    MCD::OPC_Decode, 254, 2, 38, // Opcode: FDIVQ
/* 2766 */    MCD::OPC_FilterValue, 81, 9, 0, 0, // Skip to: 2780
/* 2771 */    MCD::OPC_CheckPredicate, 2, 91, 18, 0, // Skip to: 7475
/* 2776 */    MCD::OPC_Decode, 174, 3, 37, // Opcode: FNADDS
/* 2780 */    MCD::OPC_FilterValue, 82, 9, 0, 0, // Skip to: 2794
/* 2785 */    MCD::OPC_CheckPredicate, 2, 77, 18, 0, // Skip to: 7475
/* 2790 */    MCD::OPC_Decode, 173, 3, 37, // Opcode: FNADDD
/* 2794 */    MCD::OPC_FilterValue, 89, 9, 0, 0, // Skip to: 2808
/* 2799 */    MCD::OPC_CheckPredicate, 2, 63, 18, 0, // Skip to: 7475
/* 2804 */    MCD::OPC_Decode, 183, 3, 37, // Opcode: FNMULS
/* 2808 */    MCD::OPC_FilterValue, 90, 9, 0, 0, // Skip to: 2822
/* 2813 */    MCD::OPC_CheckPredicate, 2, 49, 18, 0, // Skip to: 7475
/* 2818 */    MCD::OPC_Decode, 182, 3, 37, // Opcode: FNMULD
/* 2822 */    MCD::OPC_FilterValue, 97, 9, 0, 0, // Skip to: 2836
/* 2827 */    MCD::OPC_CheckPredicate, 2, 35, 18, 0, // Skip to: 7475
/* 2832 */    MCD::OPC_Decode, 135, 3, 37, // Opcode: FHADDS
/* 2836 */    MCD::OPC_FilterValue, 98, 9, 0, 0, // Skip to: 2850
/* 2841 */    MCD::OPC_CheckPredicate, 2, 21, 18, 0, // Skip to: 7475
/* 2846 */    MCD::OPC_Decode, 134, 3, 37, // Opcode: FHADDD
/* 2850 */    MCD::OPC_FilterValue, 101, 9, 0, 0, // Skip to: 2864
/* 2855 */    MCD::OPC_CheckPredicate, 2, 7, 18, 0, // Skip to: 7475
/* 2860 */    MCD::OPC_Decode, 137, 3, 37, // Opcode: FHSUBS
/* 2864 */    MCD::OPC_FilterValue, 102, 9, 0, 0, // Skip to: 2878
/* 2869 */    MCD::OPC_CheckPredicate, 2, 249, 17, 0, // Skip to: 7475
/* 2874 */    MCD::OPC_Decode, 136, 3, 37, // Opcode: FHSUBD
/* 2878 */    MCD::OPC_FilterValue, 105, 4, 0, 0, // Skip to: 2887
/* 2883 */    MCD::OPC_Decode, 220, 3, 39, // Opcode: FSMULD
/* 2887 */    MCD::OPC_FilterValue, 110, 4, 0, 0, // Skip to: 2896
/* 2892 */    MCD::OPC_Decode, 128, 3, 40, // Opcode: FDMULQ
/* 2896 */    MCD::OPC_FilterValue, 113, 9, 0, 0, // Skip to: 2910
/* 2901 */    MCD::OPC_CheckPredicate, 2, 217, 17, 0, // Skip to: 7475
/* 2906 */    MCD::OPC_Decode, 181, 3, 37, // Opcode: FNHADDS
/* 2910 */    MCD::OPC_FilterValue, 114, 9, 0, 0, // Skip to: 2924
/* 2915 */    MCD::OPC_CheckPredicate, 2, 203, 17, 0, // Skip to: 7475
/* 2920 */    MCD::OPC_Decode, 180, 3, 37, // Opcode: FNHADDD
/* 2924 */    MCD::OPC_FilterValue, 121, 9, 0, 0, // Skip to: 2938
/* 2929 */    MCD::OPC_CheckPredicate, 2, 189, 17, 0, // Skip to: 7475
/* 2934 */    MCD::OPC_Decode, 190, 3, 37, // Opcode: FNSMULD
/* 2938 */    MCD::OPC_FilterValue, 129, 1, 11, 0, 0, // Skip to: 2955
/* 2944 */    MCD::OPC_CheckField, 14, 5, 0, 172, 17, 0, // Skip to: 7475
/* 2951 */    MCD::OPC_Decode, 235, 3, 41, // Opcode: FSTOX
/* 2955 */    MCD::OPC_FilterValue, 130, 1, 11, 0, 0, // Skip to: 2972
/* 2961 */    MCD::OPC_CheckField, 14, 5, 0, 155, 17, 0, // Skip to: 7475
/* 2968 */    MCD::OPC_Decode, 132, 3, 34, // Opcode: FDTOX
/* 2972 */    MCD::OPC_FilterValue, 131, 1, 11, 0, 0, // Skip to: 2989
/* 2978 */    MCD::OPC_CheckField, 14, 5, 0, 138, 17, 0, // Skip to: 7475
/* 2985 */    MCD::OPC_Decode, 215, 3, 42, // Opcode: FQTOX
/* 2989 */    MCD::OPC_FilterValue, 132, 1, 11, 0, 0, // Skip to: 3006
/* 2995 */    MCD::OPC_CheckField, 14, 5, 0, 121, 17, 0, // Skip to: 7475
/* 3002 */    MCD::OPC_Decode, 245, 3, 43, // Opcode: FXTOS
/* 3006 */    MCD::OPC_FilterValue, 136, 1, 11, 0, 0, // Skip to: 3023
/* 3012 */    MCD::OPC_CheckField, 14, 5, 0, 104, 17, 0, // Skip to: 7475
/* 3019 */    MCD::OPC_Decode, 243, 3, 34, // Opcode: FXTOD
/* 3023 */    MCD::OPC_FilterValue, 140, 1, 11, 0, 0, // Skip to: 3040
/* 3029 */    MCD::OPC_CheckField, 14, 5, 0, 87, 17, 0, // Skip to: 7475
/* 3036 */    MCD::OPC_Decode, 244, 3, 44, // Opcode: FXTOQ
/* 3040 */    MCD::OPC_FilterValue, 196, 1, 11, 0, 0, // Skip to: 3057
/* 3046 */    MCD::OPC_CheckField, 14, 5, 0, 70, 17, 0, // Skip to: 7475
/* 3053 */    MCD::OPC_Decode, 140, 3, 33, // Opcode: FITOS
/* 3057 */    MCD::OPC_FilterValue, 198, 1, 11, 0, 0, // Skip to: 3074
/* 3063 */    MCD::OPC_CheckField, 14, 5, 0, 53, 17, 0, // Skip to: 7475
/* 3070 */    MCD::OPC_Decode, 131, 3, 43, // Opcode: FDTOS
/* 3074 */    MCD::OPC_FilterValue, 199, 1, 11, 0, 0, // Skip to: 3091
/* 3080 */    MCD::OPC_CheckField, 14, 5, 0, 36, 17, 0, // Skip to: 7475
/* 3087 */    MCD::OPC_Decode, 214, 3, 45, // Opcode: FQTOS
/* 3091 */    MCD::OPC_FilterValue, 200, 1, 11, 0, 0, // Skip to: 3108
/* 3097 */    MCD::OPC_CheckField, 14, 5, 0, 19, 17, 0, // Skip to: 7475
/* 3104 */    MCD::OPC_Decode, 138, 3, 41, // Opcode: FITOD
/* 3108 */    MCD::OPC_FilterValue, 201, 1, 11, 0, 0, // Skip to: 3125
/* 3114 */    MCD::OPC_CheckField, 14, 5, 0, 2, 17, 0, // Skip to: 7475
/* 3121 */    MCD::OPC_Decode, 232, 3, 41, // Opcode: FSTOD
/* 3125 */    MCD::OPC_FilterValue, 203, 1, 11, 0, 0, // Skip to: 3142
/* 3131 */    MCD::OPC_CheckField, 14, 5, 0, 241, 16, 0, // Skip to: 7475
/* 3138 */    MCD::OPC_Decode, 212, 3, 42, // Opcode: FQTOD
/* 3142 */    MCD::OPC_FilterValue, 204, 1, 11, 0, 0, // Skip to: 3159
/* 3148 */    MCD::OPC_CheckField, 14, 5, 0, 224, 16, 0, // Skip to: 7475
/* 3155 */    MCD::OPC_Decode, 139, 3, 46, // Opcode: FITOQ
/* 3159 */    MCD::OPC_FilterValue, 205, 1, 11, 0, 0, // Skip to: 3176
/* 3165 */    MCD::OPC_CheckField, 14, 5, 0, 207, 16, 0, // Skip to: 7475
/* 3172 */    MCD::OPC_Decode, 234, 3, 46, // Opcode: FSTOQ
/* 3176 */    MCD::OPC_FilterValue, 206, 1, 11, 0, 0, // Skip to: 3193
/* 3182 */    MCD::OPC_CheckField, 14, 5, 0, 190, 16, 0, // Skip to: 7475
/* 3189 */    MCD::OPC_Decode, 130, 3, 44, // Opcode: FDTOQ
/* 3193 */    MCD::OPC_FilterValue, 209, 1, 11, 0, 0, // Skip to: 3210
/* 3199 */    MCD::OPC_CheckField, 14, 5, 0, 173, 16, 0, // Skip to: 7475
/* 3206 */    MCD::OPC_Decode, 233, 3, 33, // Opcode: FSTOI
/* 3210 */    MCD::OPC_FilterValue, 210, 1, 11, 0, 0, // Skip to: 3227
/* 3216 */    MCD::OPC_CheckField, 14, 5, 0, 156, 16, 0, // Skip to: 7475
/* 3223 */    MCD::OPC_Decode, 129, 3, 43, // Opcode: FDTOI
/* 3227 */    MCD::OPC_FilterValue, 211, 1, 146, 16, 0, // Skip to: 7475
/* 3233 */    MCD::OPC_CheckField, 14, 5, 0, 139, 16, 0, // Skip to: 7475
/* 3240 */    MCD::OPC_Decode, 213, 3, 45, // Opcode: FQTOI
/* 3244 */    MCD::OPC_FilterValue, 53, 188, 1, 0, // Skip to: 3693
/* 3249 */    MCD::OPC_ExtractField, 5, 5,  // Inst{9-5} ...
/* 3252 */    MCD::OPC_FilterValue, 1, 94, 0, 0, // Skip to: 3351
/* 3257 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 3260 */    MCD::OPC_FilterValue, 0, 41, 0, 0, // Skip to: 3306
/* 3265 */    MCD::OPC_ExtractField, 10, 1,  // Inst{10} ...
/* 3268 */    MCD::OPC_FilterValue, 0, 106, 16, 0, // Skip to: 7475
/* 3273 */    MCD::OPC_ExtractField, 18, 1,  // Inst{18} ...
/* 3276 */    MCD::OPC_FilterValue, 0, 98, 16, 0, // Skip to: 7475
/* 3281 */    MCD::OPC_CheckPredicate, 0, 11, 0, 0, // Skip to: 3297
/* 3286 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, 0, // Skip to: 3297
/* 3293 */    MCD::OPC_Decode, 160, 3, 47, // Opcode: FMOVS_FCC
/* 3297 */    MCD::OPC_CheckPredicate, 0, 77, 16, 0, // Skip to: 7475
/* 3302 */    MCD::OPC_Decode, 220, 5, 48, // Opcode: V9FMOVS_FCC
/* 3306 */    MCD::OPC_FilterValue, 1, 68, 16, 0, // Skip to: 7475
/* 3311 */    MCD::OPC_ExtractField, 10, 3,  // Inst{12-10} ...
/* 3314 */    MCD::OPC_FilterValue, 0, 16, 0, 0, // Skip to: 3335
/* 3319 */    MCD::OPC_CheckPredicate, 0, 55, 16, 0, // Skip to: 7475
/* 3324 */    MCD::OPC_CheckField, 18, 1, 0, 48, 16, 0, // Skip to: 7475
/* 3331 */    MCD::OPC_Decode, 161, 3, 47, // Opcode: FMOVS_ICC
/* 3335 */    MCD::OPC_FilterValue, 4, 39, 16, 0, // Skip to: 7475
/* 3340 */    MCD::OPC_CheckField, 18, 1, 0, 32, 16, 0, // Skip to: 7475
/* 3347 */    MCD::OPC_Decode, 162, 3, 47, // Opcode: FMOVS_XCC
/* 3351 */    MCD::OPC_FilterValue, 2, 94, 0, 0, // Skip to: 3450
/* 3356 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 3359 */    MCD::OPC_FilterValue, 0, 41, 0, 0, // Skip to: 3405
/* 3364 */    MCD::OPC_ExtractField, 10, 1,  // Inst{10} ...
/* 3367 */    MCD::OPC_FilterValue, 0, 7, 16, 0, // Skip to: 7475
/* 3372 */    MCD::OPC_ExtractField, 18, 1,  // Inst{18} ...
/* 3375 */    MCD::OPC_FilterValue, 0, 255, 15, 0, // Skip to: 7475
/* 3380 */    MCD::OPC_CheckPredicate, 0, 11, 0, 0, // Skip to: 3396
/* 3385 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, 0, // Skip to: 3396
/* 3392 */    MCD::OPC_Decode, 149, 3, 49, // Opcode: FMOVD_FCC
/* 3396 */    MCD::OPC_CheckPredicate, 0, 234, 15, 0, // Skip to: 7475
/* 3401 */    MCD::OPC_Decode, 218, 5, 50, // Opcode: V9FMOVD_FCC
/* 3405 */    MCD::OPC_FilterValue, 1, 225, 15, 0, // Skip to: 7475
/* 3410 */    MCD::OPC_ExtractField, 10, 3,  // Inst{12-10} ...
/* 3413 */    MCD::OPC_FilterValue, 0, 16, 0, 0, // Skip to: 3434
/* 3418 */    MCD::OPC_CheckPredicate, 0, 212, 15, 0, // Skip to: 7475
/* 3423 */    MCD::OPC_CheckField, 18, 1, 0, 205, 15, 0, // Skip to: 7475
/* 3430 */    MCD::OPC_Decode, 150, 3, 49, // Opcode: FMOVD_ICC
/* 3434 */    MCD::OPC_FilterValue, 4, 196, 15, 0, // Skip to: 7475
/* 3439 */    MCD::OPC_CheckField, 18, 1, 0, 189, 15, 0, // Skip to: 7475
/* 3446 */    MCD::OPC_Decode, 151, 3, 49, // Opcode: FMOVD_XCC
/* 3450 */    MCD::OPC_FilterValue, 3, 94, 0, 0, // Skip to: 3549
/* 3455 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 3458 */    MCD::OPC_FilterValue, 0, 41, 0, 0, // Skip to: 3504
/* 3463 */    MCD::OPC_ExtractField, 10, 1,  // Inst{10} ...
/* 3466 */    MCD::OPC_FilterValue, 0, 164, 15, 0, // Skip to: 7475
/* 3471 */    MCD::OPC_ExtractField, 18, 1,  // Inst{18} ...
/* 3474 */    MCD::OPC_FilterValue, 0, 156, 15, 0, // Skip to: 7475
/* 3479 */    MCD::OPC_CheckPredicate, 0, 11, 0, 0, // Skip to: 3495
/* 3484 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, 0, // Skip to: 3495
/* 3491 */    MCD::OPC_Decode, 153, 3, 51, // Opcode: FMOVQ_FCC
/* 3495 */    MCD::OPC_CheckPredicate, 0, 135, 15, 0, // Skip to: 7475
/* 3500 */    MCD::OPC_Decode, 219, 5, 52, // Opcode: V9FMOVQ_FCC
/* 3504 */    MCD::OPC_FilterValue, 1, 126, 15, 0, // Skip to: 7475
/* 3509 */    MCD::OPC_ExtractField, 10, 3,  // Inst{12-10} ...
/* 3512 */    MCD::OPC_FilterValue, 0, 16, 0, 0, // Skip to: 3533
/* 3517 */    MCD::OPC_CheckPredicate, 0, 113, 15, 0, // Skip to: 7475
/* 3522 */    MCD::OPC_CheckField, 18, 1, 0, 106, 15, 0, // Skip to: 7475
/* 3529 */    MCD::OPC_Decode, 154, 3, 51, // Opcode: FMOVQ_ICC
/* 3533 */    MCD::OPC_FilterValue, 4, 97, 15, 0, // Skip to: 7475
/* 3538 */    MCD::OPC_CheckField, 18, 1, 0, 90, 15, 0, // Skip to: 7475
/* 3545 */    MCD::OPC_Decode, 155, 3, 51, // Opcode: FMOVQ_XCC
/* 3549 */    MCD::OPC_FilterValue, 5, 11, 0, 0, // Skip to: 3565
/* 3554 */    MCD::OPC_CheckField, 13, 1, 0, 74, 15, 0, // Skip to: 7475
/* 3561 */    MCD::OPC_Decode, 158, 3, 53, // Opcode: FMOVRS
/* 3565 */    MCD::OPC_FilterValue, 6, 11, 0, 0, // Skip to: 3581
/* 3570 */    MCD::OPC_CheckField, 13, 1, 0, 58, 15, 0, // Skip to: 7475
/* 3577 */    MCD::OPC_Decode, 156, 3, 54, // Opcode: FMOVRD
/* 3581 */    MCD::OPC_FilterValue, 7, 11, 0, 0, // Skip to: 3597
/* 3586 */    MCD::OPC_CheckField, 13, 1, 0, 42, 15, 0, // Skip to: 7475
/* 3593 */    MCD::OPC_Decode, 157, 3, 55, // Opcode: FMOVRQ
/* 3597 */    MCD::OPC_FilterValue, 17, 11, 0, 0, // Skip to: 3613
/* 3602 */    MCD::OPC_CheckField, 10, 4, 2, 26, 15, 0, // Skip to: 7475
/* 3609 */    MCD::OPC_Decode, 217, 5, 56, // Opcode: V9FCMPS
/* 3613 */    MCD::OPC_FilterValue, 18, 11, 0, 0, // Skip to: 3629
/* 3618 */    MCD::OPC_CheckField, 10, 4, 2, 10, 15, 0, // Skip to: 7475
/* 3625 */    MCD::OPC_Decode, 212, 5, 57, // Opcode: V9FCMPD
/* 3629 */    MCD::OPC_FilterValue, 19, 11, 0, 0, // Skip to: 3645
/* 3634 */    MCD::OPC_CheckField, 10, 4, 2, 250, 14, 0, // Skip to: 7475
/* 3641 */    MCD::OPC_Decode, 216, 5, 58, // Opcode: V9FCMPQ
/* 3645 */    MCD::OPC_FilterValue, 21, 11, 0, 0, // Skip to: 3661
/* 3650 */    MCD::OPC_CheckField, 10, 4, 2, 234, 14, 0, // Skip to: 7475
/* 3657 */    MCD::OPC_Decode, 215, 5, 56, // Opcode: V9FCMPES
/* 3661 */    MCD::OPC_FilterValue, 22, 11, 0, 0, // Skip to: 3677
/* 3666 */    MCD::OPC_CheckField, 10, 4, 2, 218, 14, 0, // Skip to: 7475
/* 3673 */    MCD::OPC_Decode, 213, 5, 57, // Opcode: V9FCMPED
/* 3677 */    MCD::OPC_FilterValue, 23, 209, 14, 0, // Skip to: 7475
/* 3682 */    MCD::OPC_CheckField, 10, 4, 2, 202, 14, 0, // Skip to: 7475
/* 3689 */    MCD::OPC_Decode, 214, 5, 58, // Opcode: V9FCMPEQ
/* 3693 */    MCD::OPC_FilterValue, 54, 35, 7, 0, // Skip to: 5525
/* 3698 */    MCD::OPC_ExtractField, 5, 9,  // Inst{13-5} ...
/* 3701 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 3715
/* 3706 */    MCD::OPC_CheckPredicate, 3, 180, 14, 0, // Skip to: 7475
/* 3711 */    MCD::OPC_Decode, 217, 2, 10, // Opcode: EDGE8
/* 3715 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 3729
/* 3720 */    MCD::OPC_CheckPredicate, 4, 166, 14, 0, // Skip to: 7475
/* 3725 */    MCD::OPC_Decode, 220, 2, 10, // Opcode: EDGE8N
/* 3729 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 3743
/* 3734 */    MCD::OPC_CheckPredicate, 3, 152, 14, 0, // Skip to: 7475
/* 3739 */    MCD::OPC_Decode, 218, 2, 10, // Opcode: EDGE8L
/* 3743 */    MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 3757
/* 3748 */    MCD::OPC_CheckPredicate, 4, 138, 14, 0, // Skip to: 7475
/* 3753 */    MCD::OPC_Decode, 219, 2, 10, // Opcode: EDGE8LN
/* 3757 */    MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 3771
/* 3762 */    MCD::OPC_CheckPredicate, 3, 124, 14, 0, // Skip to: 7475
/* 3767 */    MCD::OPC_Decode, 209, 2, 10, // Opcode: EDGE16
/* 3771 */    MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 3785
/* 3776 */    MCD::OPC_CheckPredicate, 4, 110, 14, 0, // Skip to: 7475
/* 3781 */    MCD::OPC_Decode, 212, 2, 10, // Opcode: EDGE16N
/* 3785 */    MCD::OPC_FilterValue, 6, 9, 0, 0, // Skip to: 3799
/* 3790 */    MCD::OPC_CheckPredicate, 3, 96, 14, 0, // Skip to: 7475
/* 3795 */    MCD::OPC_Decode, 210, 2, 10, // Opcode: EDGE16L
/* 3799 */    MCD::OPC_FilterValue, 7, 9, 0, 0, // Skip to: 3813
/* 3804 */    MCD::OPC_CheckPredicate, 4, 82, 14, 0, // Skip to: 7475
/* 3809 */    MCD::OPC_Decode, 211, 2, 10, // Opcode: EDGE16LN
/* 3813 */    MCD::OPC_FilterValue, 8, 9, 0, 0, // Skip to: 3827
/* 3818 */    MCD::OPC_CheckPredicate, 3, 68, 14, 0, // Skip to: 7475
/* 3823 */    MCD::OPC_Decode, 213, 2, 10, // Opcode: EDGE32
/* 3827 */    MCD::OPC_FilterValue, 9, 9, 0, 0, // Skip to: 3841
/* 3832 */    MCD::OPC_CheckPredicate, 4, 54, 14, 0, // Skip to: 7475
/* 3837 */    MCD::OPC_Decode, 216, 2, 10, // Opcode: EDGE32N
/* 3841 */    MCD::OPC_FilterValue, 10, 9, 0, 0, // Skip to: 3855
/* 3846 */    MCD::OPC_CheckPredicate, 3, 40, 14, 0, // Skip to: 7475
/* 3851 */    MCD::OPC_Decode, 214, 2, 10, // Opcode: EDGE32L
/* 3855 */    MCD::OPC_FilterValue, 11, 9, 0, 0, // Skip to: 3869
/* 3860 */    MCD::OPC_CheckPredicate, 4, 26, 14, 0, // Skip to: 7475
/* 3865 */    MCD::OPC_Decode, 215, 2, 10, // Opcode: EDGE32LN
/* 3869 */    MCD::OPC_FilterValue, 16, 9, 0, 0, // Skip to: 3883
/* 3874 */    MCD::OPC_CheckPredicate, 3, 12, 14, 0, // Skip to: 7475
/* 3879 */    MCD::OPC_Decode, 171, 2, 10, // Opcode: ARRAY8
/* 3883 */    MCD::OPC_FilterValue, 17, 9, 0, 0, // Skip to: 3897
/* 3888 */    MCD::OPC_CheckPredicate, 2, 254, 13, 0, // Skip to: 7475
/* 3893 */    MCD::OPC_Decode, 150, 2, 10, // Opcode: ADDXC
/* 3897 */    MCD::OPC_FilterValue, 18, 9, 0, 0, // Skip to: 3911
/* 3902 */    MCD::OPC_CheckPredicate, 3, 240, 13, 0, // Skip to: 7475
/* 3907 */    MCD::OPC_Decode, 169, 2, 10, // Opcode: ARRAY16
/* 3911 */    MCD::OPC_FilterValue, 19, 9, 0, 0, // Skip to: 3925
/* 3916 */    MCD::OPC_CheckPredicate, 2, 226, 13, 0, // Skip to: 7475
/* 3921 */    MCD::OPC_Decode, 151, 2, 10, // Opcode: ADDXCCC
/* 3925 */    MCD::OPC_FilterValue, 20, 9, 0, 0, // Skip to: 3939
/* 3930 */    MCD::OPC_CheckPredicate, 3, 212, 13, 0, // Skip to: 7475
/* 3935 */    MCD::OPC_Decode, 170, 2, 10, // Opcode: ARRAY32
/* 3939 */    MCD::OPC_FilterValue, 22, 9, 0, 0, // Skip to: 3953
/* 3944 */    MCD::OPC_CheckPredicate, 2, 198, 13, 0, // Skip to: 7475
/* 3949 */    MCD::OPC_Decode, 208, 5, 10, // Opcode: UMULXHI
/* 3953 */    MCD::OPC_FilterValue, 23, 16, 0, 0, // Skip to: 3974
/* 3958 */    MCD::OPC_CheckPredicate, 2, 184, 13, 0, // Skip to: 7475
/* 3963 */    MCD::OPC_CheckField, 14, 5, 0, 177, 13, 0, // Skip to: 7475
/* 3970 */    MCD::OPC_Decode, 170, 4, 59, // Opcode: LZCNT
/* 3974 */    MCD::OPC_FilterValue, 24, 9, 0, 0, // Skip to: 3988
/* 3979 */    MCD::OPC_CheckPredicate, 3, 163, 13, 0, // Skip to: 7475
/* 3984 */    MCD::OPC_Decode, 156, 2, 10, // Opcode: ALIGNADDR
/* 3988 */    MCD::OPC_FilterValue, 25, 9, 0, 0, // Skip to: 4002
/* 3993 */    MCD::OPC_CheckPredicate, 4, 149, 13, 0, // Skip to: 7475
/* 3998 */    MCD::OPC_Decode, 177, 2, 10, // Opcode: BMASK
/* 4002 */    MCD::OPC_FilterValue, 26, 9, 0, 0, // Skip to: 4016
/* 4007 */    MCD::OPC_CheckPredicate, 3, 135, 13, 0, // Skip to: 7475
/* 4012 */    MCD::OPC_Decode, 157, 2, 10, // Opcode: ALIGNADDRL
/* 4016 */    MCD::OPC_FilterValue, 27, 23, 0, 0, // Skip to: 4044
/* 4021 */    MCD::OPC_CheckPredicate, 2, 121, 13, 0, // Skip to: 7475
/* 4026 */    MCD::OPC_CheckField, 25, 5, 0, 114, 13, 0, // Skip to: 7475
/* 4033 */    MCD::OPC_CheckField, 14, 5, 0, 107, 13, 0, // Skip to: 7475
/* 4040 */    MCD::OPC_Decode, 206, 2, 60, // Opcode: CMASK8
/* 4044 */    MCD::OPC_FilterValue, 28, 9, 0, 0, // Skip to: 4058
/* 4049 */    MCD::OPC_CheckPredicate, 4, 93, 13, 0, // Skip to: 7475
/* 4054 */    MCD::OPC_Decode, 194, 2, 37, // Opcode: BSHUFFLE
/* 4058 */    MCD::OPC_FilterValue, 29, 23, 0, 0, // Skip to: 4086
/* 4063 */    MCD::OPC_CheckPredicate, 2, 79, 13, 0, // Skip to: 7475
/* 4068 */    MCD::OPC_CheckField, 25, 5, 0, 72, 13, 0, // Skip to: 7475
/* 4075 */    MCD::OPC_CheckField, 14, 5, 0, 65, 13, 0, // Skip to: 7475
/* 4082 */    MCD::OPC_Decode, 204, 2, 60, // Opcode: CMASK16
/* 4086 */    MCD::OPC_FilterValue, 31, 23, 0, 0, // Skip to: 4114
/* 4091 */    MCD::OPC_CheckPredicate, 2, 51, 13, 0, // Skip to: 7475
/* 4096 */    MCD::OPC_CheckField, 25, 5, 0, 44, 13, 0, // Skip to: 7475
/* 4103 */    MCD::OPC_CheckField, 14, 5, 0, 37, 13, 0, // Skip to: 7475
/* 4110 */    MCD::OPC_Decode, 205, 2, 60, // Opcode: CMASK32
/* 4114 */    MCD::OPC_FilterValue, 32, 9, 0, 0, // Skip to: 4128
/* 4119 */    MCD::OPC_CheckPredicate, 3, 23, 13, 0, // Skip to: 7475
/* 4124 */    MCD::OPC_Decode, 245, 2, 61, // Opcode: FCMPLE16
/* 4128 */    MCD::OPC_FilterValue, 33, 9, 0, 0, // Skip to: 4142
/* 4133 */    MCD::OPC_CheckPredicate, 2, 9, 13, 0, // Skip to: 7475
/* 4138 */    MCD::OPC_Decode, 218, 3, 37, // Opcode: FSLL16
/* 4142 */    MCD::OPC_FilterValue, 34, 9, 0, 0, // Skip to: 4156
/* 4147 */    MCD::OPC_CheckPredicate, 3, 251, 12, 0, // Skip to: 7475
/* 4152 */    MCD::OPC_Decode, 247, 2, 61, // Opcode: FCMPNE16
/* 4156 */    MCD::OPC_FilterValue, 35, 9, 0, 0, // Skip to: 4170
/* 4161 */    MCD::OPC_CheckPredicate, 2, 237, 12, 0, // Skip to: 7475
/* 4166 */    MCD::OPC_Decode, 230, 3, 37, // Opcode: FSRL16
/* 4170 */    MCD::OPC_FilterValue, 36, 9, 0, 0, // Skip to: 4184
/* 4175 */    MCD::OPC_CheckPredicate, 3, 223, 12, 0, // Skip to: 7475
/* 4180 */    MCD::OPC_Decode, 246, 2, 61, // Opcode: FCMPLE32
/* 4184 */    MCD::OPC_FilterValue, 37, 9, 0, 0, // Skip to: 4198
/* 4189 */    MCD::OPC_CheckPredicate, 2, 209, 12, 0, // Skip to: 7475
/* 4194 */    MCD::OPC_Decode, 219, 3, 37, // Opcode: FSLL32
/* 4198 */    MCD::OPC_FilterValue, 38, 9, 0, 0, // Skip to: 4212
/* 4203 */    MCD::OPC_CheckPredicate, 3, 195, 12, 0, // Skip to: 7475
/* 4208 */    MCD::OPC_Decode, 248, 2, 61, // Opcode: FCMPNE32
/* 4212 */    MCD::OPC_FilterValue, 39, 9, 0, 0, // Skip to: 4226
/* 4217 */    MCD::OPC_CheckPredicate, 2, 181, 12, 0, // Skip to: 7475
/* 4222 */    MCD::OPC_Decode, 231, 3, 37, // Opcode: FSRL32
/* 4226 */    MCD::OPC_FilterValue, 40, 9, 0, 0, // Skip to: 4240
/* 4231 */    MCD::OPC_CheckPredicate, 3, 167, 12, 0, // Skip to: 7475
/* 4236 */    MCD::OPC_Decode, 243, 2, 61, // Opcode: FCMPGT16
/* 4240 */    MCD::OPC_FilterValue, 41, 9, 0, 0, // Skip to: 4254
/* 4245 */    MCD::OPC_CheckPredicate, 2, 153, 12, 0, // Skip to: 7475
/* 4250 */    MCD::OPC_Decode, 216, 3, 37, // Opcode: FSLAS16
/* 4254 */    MCD::OPC_FilterValue, 42, 9, 0, 0, // Skip to: 4268
/* 4259 */    MCD::OPC_CheckPredicate, 3, 139, 12, 0, // Skip to: 7475
/* 4264 */    MCD::OPC_Decode, 241, 2, 61, // Opcode: FCMPEQ16
/* 4268 */    MCD::OPC_FilterValue, 43, 9, 0, 0, // Skip to: 4282
/* 4273 */    MCD::OPC_CheckPredicate, 2, 125, 12, 0, // Skip to: 7475
/* 4278 */    MCD::OPC_Decode, 224, 3, 37, // Opcode: FSRA16
/* 4282 */    MCD::OPC_FilterValue, 44, 9, 0, 0, // Skip to: 4296
/* 4287 */    MCD::OPC_CheckPredicate, 3, 111, 12, 0, // Skip to: 7475
/* 4292 */    MCD::OPC_Decode, 244, 2, 61, // Opcode: FCMPGT32
/* 4296 */    MCD::OPC_FilterValue, 45, 9, 0, 0, // Skip to: 4310
/* 4301 */    MCD::OPC_CheckPredicate, 2, 97, 12, 0, // Skip to: 7475
/* 4306 */    MCD::OPC_Decode, 217, 3, 37, // Opcode: FSLAS32
/* 4310 */    MCD::OPC_FilterValue, 46, 9, 0, 0, // Skip to: 4324
/* 4315 */    MCD::OPC_CheckPredicate, 3, 83, 12, 0, // Skip to: 7475
/* 4320 */    MCD::OPC_Decode, 242, 2, 61, // Opcode: FCMPEQ32
/* 4324 */    MCD::OPC_FilterValue, 47, 9, 0, 0, // Skip to: 4338
/* 4329 */    MCD::OPC_CheckPredicate, 2, 69, 12, 0, // Skip to: 7475
/* 4334 */    MCD::OPC_Decode, 225, 3, 37, // Opcode: FSRA32
/* 4338 */    MCD::OPC_FilterValue, 49, 9, 0, 0, // Skip to: 4352
/* 4343 */    MCD::OPC_CheckPredicate, 3, 55, 12, 0, // Skip to: 7475
/* 4348 */    MCD::OPC_Decode, 165, 3, 37, // Opcode: FMUL8X16
/* 4352 */    MCD::OPC_FilterValue, 51, 9, 0, 0, // Skip to: 4366
/* 4357 */    MCD::OPC_CheckPredicate, 3, 41, 12, 0, // Skip to: 7475
/* 4362 */    MCD::OPC_Decode, 167, 3, 37, // Opcode: FMUL8X16AU
/* 4366 */    MCD::OPC_FilterValue, 53, 9, 0, 0, // Skip to: 4380
/* 4371 */    MCD::OPC_CheckPredicate, 3, 27, 12, 0, // Skip to: 7475
/* 4376 */    MCD::OPC_Decode, 166, 3, 37, // Opcode: FMUL8X16AL
/* 4380 */    MCD::OPC_FilterValue, 54, 9, 0, 0, // Skip to: 4394
/* 4385 */    MCD::OPC_CheckPredicate, 3, 13, 12, 0, // Skip to: 7475
/* 4390 */    MCD::OPC_Decode, 163, 3, 37, // Opcode: FMUL8SUX16
/* 4394 */    MCD::OPC_FilterValue, 55, 9, 0, 0, // Skip to: 4408
/* 4399 */    MCD::OPC_CheckPredicate, 3, 255, 11, 0, // Skip to: 7475
/* 4404 */    MCD::OPC_Decode, 164, 3, 37, // Opcode: FMUL8ULX16
/* 4408 */    MCD::OPC_FilterValue, 56, 9, 0, 0, // Skip to: 4422
/* 4413 */    MCD::OPC_CheckPredicate, 3, 241, 11, 0, // Skip to: 7475
/* 4418 */    MCD::OPC_Decode, 169, 3, 37, // Opcode: FMULD8SUX16
/* 4422 */    MCD::OPC_FilterValue, 57, 9, 0, 0, // Skip to: 4436
/* 4427 */    MCD::OPC_CheckPredicate, 3, 227, 11, 0, // Skip to: 7475
/* 4432 */    MCD::OPC_Decode, 170, 3, 37, // Opcode: FMULD8ULX16
/* 4436 */    MCD::OPC_FilterValue, 58, 9, 0, 0, // Skip to: 4450
/* 4441 */    MCD::OPC_CheckPredicate, 3, 213, 11, 0, // Skip to: 7475
/* 4446 */    MCD::OPC_Decode, 200, 3, 37, // Opcode: FPACK32
/* 4450 */    MCD::OPC_FilterValue, 59, 16, 0, 0, // Skip to: 4471
/* 4455 */    MCD::OPC_CheckPredicate, 3, 199, 11, 0, // Skip to: 7475
/* 4460 */    MCD::OPC_CheckField, 14, 5, 0, 192, 11, 0, // Skip to: 7475
/* 4467 */    MCD::OPC_Decode, 199, 3, 34, // Opcode: FPACK16
/* 4471 */    MCD::OPC_FilterValue, 61, 16, 0, 0, // Skip to: 4492
/* 4476 */    MCD::OPC_CheckPredicate, 3, 178, 11, 0, // Skip to: 7475
/* 4481 */    MCD::OPC_CheckField, 14, 5, 0, 171, 11, 0, // Skip to: 7475
/* 4488 */    MCD::OPC_Decode, 201, 3, 34, // Opcode: FPACKFIX
/* 4492 */    MCD::OPC_FilterValue, 62, 9, 0, 0, // Skip to: 4506
/* 4497 */    MCD::OPC_CheckPredicate, 3, 157, 11, 0, // Skip to: 7475
/* 4502 */    MCD::OPC_Decode, 201, 4, 37, // Opcode: PDIST
/* 4506 */    MCD::OPC_FilterValue, 63, 9, 0, 0, // Skip to: 4520
/* 4511 */    MCD::OPC_CheckPredicate, 2, 143, 11, 0, // Skip to: 7475
/* 4516 */    MCD::OPC_Decode, 202, 4, 37, // Opcode: PDISTN
/* 4520 */    MCD::OPC_FilterValue, 64, 9, 0, 0, // Skip to: 4534
/* 4525 */    MCD::OPC_CheckPredicate, 2, 129, 11, 0, // Skip to: 7475
/* 4530 */    MCD::OPC_Decode, 147, 3, 37, // Opcode: FMEAN16
/* 4534 */    MCD::OPC_FilterValue, 66, 9, 0, 0, // Skip to: 4548
/* 4539 */    MCD::OPC_CheckPredicate, 2, 115, 11, 0, // Skip to: 7475
/* 4544 */    MCD::OPC_Decode, 206, 3, 37, // Opcode: FPADD64
/* 4548 */    MCD::OPC_FilterValue, 68, 9, 0, 0, // Skip to: 4562
/* 4553 */    MCD::OPC_CheckPredicate, 2, 101, 11, 0, // Skip to: 7475
/* 4558 */    MCD::OPC_Decode, 238, 2, 37, // Opcode: FCHKSM16
/* 4562 */    MCD::OPC_FilterValue, 72, 9, 0, 0, // Skip to: 4576
/* 4567 */    MCD::OPC_CheckPredicate, 3, 87, 11, 0, // Skip to: 7475
/* 4572 */    MCD::OPC_Decode, 227, 2, 37, // Opcode: FALIGNADATA
/* 4576 */    MCD::OPC_FilterValue, 75, 9, 0, 0, // Skip to: 4590
/* 4581 */    MCD::OPC_CheckPredicate, 3, 73, 11, 0, // Skip to: 7475
/* 4586 */    MCD::OPC_Decode, 207, 3, 37, // Opcode: FPMERGE
/* 4590 */    MCD::OPC_FilterValue, 77, 16, 0, 0, // Skip to: 4611
/* 4595 */    MCD::OPC_CheckPredicate, 3, 59, 11, 0, // Skip to: 7475
/* 4600 */    MCD::OPC_CheckField, 14, 5, 0, 52, 11, 0, // Skip to: 7475
/* 4607 */    MCD::OPC_Decode, 133, 3, 34, // Opcode: FEXPAND
/* 4611 */    MCD::OPC_FilterValue, 80, 9, 0, 0, // Skip to: 4625
/* 4616 */    MCD::OPC_CheckPredicate, 3, 38, 11, 0, // Skip to: 7475
/* 4621 */    MCD::OPC_Decode, 202, 3, 37, // Opcode: FPADD16
/* 4625 */    MCD::OPC_FilterValue, 81, 9, 0, 0, // Skip to: 4639
/* 4630 */    MCD::OPC_CheckPredicate, 3, 24, 11, 0, // Skip to: 7475
/* 4635 */    MCD::OPC_Decode, 203, 3, 37, // Opcode: FPADD16S
/* 4639 */    MCD::OPC_FilterValue, 82, 9, 0, 0, // Skip to: 4653
/* 4644 */    MCD::OPC_CheckPredicate, 3, 10, 11, 0, // Skip to: 7475
/* 4649 */    MCD::OPC_Decode, 204, 3, 37, // Opcode: FPADD32
/* 4653 */    MCD::OPC_FilterValue, 83, 9, 0, 0, // Skip to: 4667
/* 4658 */    MCD::OPC_CheckPredicate, 3, 252, 10, 0, // Skip to: 7475
/* 4663 */    MCD::OPC_Decode, 205, 3, 37, // Opcode: FPADD32S
/* 4667 */    MCD::OPC_FilterValue, 84, 9, 0, 0, // Skip to: 4681
/* 4672 */    MCD::OPC_CheckPredicate, 3, 238, 10, 0, // Skip to: 7475
/* 4677 */    MCD::OPC_Decode, 208, 3, 37, // Opcode: FPSUB16
/* 4681 */    MCD::OPC_FilterValue, 85, 9, 0, 0, // Skip to: 4695
/* 4686 */    MCD::OPC_CheckPredicate, 3, 224, 10, 0, // Skip to: 7475
/* 4691 */    MCD::OPC_Decode, 209, 3, 37, // Opcode: FPSUB16S
/* 4695 */    MCD::OPC_FilterValue, 86, 9, 0, 0, // Skip to: 4709
/* 4700 */    MCD::OPC_CheckPredicate, 3, 210, 10, 0, // Skip to: 7475
/* 4705 */    MCD::OPC_Decode, 210, 3, 37, // Opcode: FPSUB32
/* 4709 */    MCD::OPC_FilterValue, 87, 9, 0, 0, // Skip to: 4723
/* 4714 */    MCD::OPC_CheckPredicate, 3, 196, 10, 0, // Skip to: 7475
/* 4719 */    MCD::OPC_Decode, 211, 3, 37, // Opcode: FPSUB32S
/* 4723 */    MCD::OPC_FilterValue, 96, 23, 0, 0, // Skip to: 4751
/* 4728 */    MCD::OPC_CheckPredicate, 3, 182, 10, 0, // Skip to: 7475
/* 4733 */    MCD::OPC_CheckField, 14, 5, 0, 175, 10, 0, // Skip to: 7475
/* 4740 */    MCD::OPC_CheckField, 0, 5, 0, 168, 10, 0, // Skip to: 7475
/* 4747 */    MCD::OPC_Decode, 246, 3, 62, // Opcode: FZERO
/* 4751 */    MCD::OPC_FilterValue, 97, 23, 0, 0, // Skip to: 4779
/* 4756 */    MCD::OPC_CheckPredicate, 3, 154, 10, 0, // Skip to: 7475
/* 4761 */    MCD::OPC_CheckField, 14, 5, 0, 147, 10, 0, // Skip to: 7475
/* 4768 */    MCD::OPC_CheckField, 0, 5, 0, 140, 10, 0, // Skip to: 7475
/* 4775 */    MCD::OPC_Decode, 247, 3, 63, // Opcode: FZEROS
/* 4779 */    MCD::OPC_FilterValue, 98, 9, 0, 0, // Skip to: 4793
/* 4784 */    MCD::OPC_CheckPredicate, 3, 126, 10, 0, // Skip to: 7475
/* 4789 */    MCD::OPC_Decode, 184, 3, 37, // Opcode: FNOR
/* 4793 */    MCD::OPC_FilterValue, 99, 9, 0, 0, // Skip to: 4807
/* 4798 */    MCD::OPC_CheckPredicate, 3, 112, 10, 0, // Skip to: 7475
/* 4803 */    MCD::OPC_Decode, 185, 3, 36, // Opcode: FNORS
/* 4807 */    MCD::OPC_FilterValue, 100, 9, 0, 0, // Skip to: 4821
/* 4812 */    MCD::OPC_CheckPredicate, 3, 98, 10, 0, // Skip to: 7475
/* 4817 */    MCD::OPC_Decode, 231, 2, 37, // Opcode: FANDNOT2
/* 4821 */    MCD::OPC_FilterValue, 101, 9, 0, 0, // Skip to: 4835
/* 4826 */    MCD::OPC_CheckPredicate, 3, 84, 10, 0, // Skip to: 7475
/* 4831 */    MCD::OPC_Decode, 232, 2, 36, // Opcode: FANDNOT2S
/* 4835 */    MCD::OPC_FilterValue, 102, 16, 0, 0, // Skip to: 4856
/* 4840 */    MCD::OPC_CheckPredicate, 3, 70, 10, 0, // Skip to: 7475
/* 4845 */    MCD::OPC_CheckField, 14, 5, 0, 63, 10, 0, // Skip to: 7475
/* 4852 */    MCD::OPC_Decode, 188, 3, 34, // Opcode: FNOT2
/* 4856 */    MCD::OPC_FilterValue, 103, 16, 0, 0, // Skip to: 4877
/* 4861 */    MCD::OPC_CheckPredicate, 3, 49, 10, 0, // Skip to: 7475
/* 4866 */    MCD::OPC_CheckField, 14, 5, 0, 42, 10, 0, // Skip to: 7475
/* 4873 */    MCD::OPC_Decode, 189, 3, 33, // Opcode: FNOT2S
/* 4877 */    MCD::OPC_FilterValue, 104, 9, 0, 0, // Skip to: 4891
/* 4882 */    MCD::OPC_CheckPredicate, 3, 28, 10, 0, // Skip to: 7475
/* 4887 */    MCD::OPC_Decode, 229, 2, 37, // Opcode: FANDNOT1
/* 4891 */    MCD::OPC_FilterValue, 105, 9, 0, 0, // Skip to: 4905
/* 4896 */    MCD::OPC_CheckPredicate, 3, 14, 10, 0, // Skip to: 7475
/* 4901 */    MCD::OPC_Decode, 230, 2, 36, // Opcode: FANDNOT1S
/* 4905 */    MCD::OPC_FilterValue, 106, 16, 0, 0, // Skip to: 4926
/* 4910 */    MCD::OPC_CheckPredicate, 3, 0, 10, 0, // Skip to: 7475
/* 4915 */    MCD::OPC_CheckField, 0, 5, 0, 249, 9, 0, // Skip to: 7475
/* 4922 */    MCD::OPC_Decode, 186, 3, 64, // Opcode: FNOT1
/* 4926 */    MCD::OPC_FilterValue, 107, 16, 0, 0, // Skip to: 4947
/* 4931 */    MCD::OPC_CheckPredicate, 3, 235, 9, 0, // Skip to: 7475
/* 4936 */    MCD::OPC_CheckField, 0, 5, 0, 228, 9, 0, // Skip to: 7475
/* 4943 */    MCD::OPC_Decode, 187, 3, 65, // Opcode: FNOT1S
/* 4947 */    MCD::OPC_FilterValue, 108, 9, 0, 0, // Skip to: 4961
/* 4952 */    MCD::OPC_CheckPredicate, 3, 214, 9, 0, // Skip to: 7475
/* 4957 */    MCD::OPC_Decode, 241, 3, 37, // Opcode: FXOR
/* 4961 */    MCD::OPC_FilterValue, 109, 9, 0, 0, // Skip to: 4975
/* 4966 */    MCD::OPC_CheckPredicate, 3, 200, 9, 0, // Skip to: 7475
/* 4971 */    MCD::OPC_Decode, 242, 3, 36, // Opcode: FXORS
/* 4975 */    MCD::OPC_FilterValue, 110, 9, 0, 0, // Skip to: 4989
/* 4980 */    MCD::OPC_CheckPredicate, 3, 186, 9, 0, // Skip to: 7475
/* 4985 */    MCD::OPC_Decode, 175, 3, 37, // Opcode: FNAND
/* 4989 */    MCD::OPC_FilterValue, 111, 9, 0, 0, // Skip to: 5003
/* 4994 */    MCD::OPC_CheckPredicate, 3, 172, 9, 0, // Skip to: 7475
/* 4999 */    MCD::OPC_Decode, 176, 3, 36, // Opcode: FNANDS
/* 5003 */    MCD::OPC_FilterValue, 112, 9, 0, 0, // Skip to: 5017
/* 5008 */    MCD::OPC_CheckPredicate, 3, 158, 9, 0, // Skip to: 7475
/* 5013 */    MCD::OPC_Decode, 228, 2, 37, // Opcode: FAND
/* 5017 */    MCD::OPC_FilterValue, 113, 9, 0, 0, // Skip to: 5031
/* 5022 */    MCD::OPC_CheckPredicate, 3, 144, 9, 0, // Skip to: 7475
/* 5027 */    MCD::OPC_Decode, 233, 2, 36, // Opcode: FANDS
/* 5031 */    MCD::OPC_FilterValue, 114, 9, 0, 0, // Skip to: 5045
/* 5036 */    MCD::OPC_CheckPredicate, 3, 130, 9, 0, // Skip to: 7475
/* 5041 */    MCD::OPC_Decode, 239, 3, 37, // Opcode: FXNOR
/* 5045 */    MCD::OPC_FilterValue, 115, 9, 0, 0, // Skip to: 5059
/* 5050 */    MCD::OPC_CheckPredicate, 3, 116, 9, 0, // Skip to: 7475
/* 5055 */    MCD::OPC_Decode, 240, 3, 36, // Opcode: FXNORS
/* 5059 */    MCD::OPC_FilterValue, 116, 16, 0, 0, // Skip to: 5080
/* 5064 */    MCD::OPC_CheckPredicate, 3, 102, 9, 0, // Skip to: 7475
/* 5069 */    MCD::OPC_CheckField, 0, 5, 0, 95, 9, 0, // Skip to: 7475
/* 5076 */    MCD::OPC_Decode, 226, 3, 64, // Opcode: FSRC1
/* 5080 */    MCD::OPC_FilterValue, 117, 16, 0, 0, // Skip to: 5101
/* 5085 */    MCD::OPC_CheckPredicate, 3, 81, 9, 0, // Skip to: 7475
/* 5090 */    MCD::OPC_CheckField, 0, 5, 0, 74, 9, 0, // Skip to: 7475
/* 5097 */    MCD::OPC_Decode, 227, 3, 65, // Opcode: FSRC1S
/* 5101 */    MCD::OPC_FilterValue, 118, 9, 0, 0, // Skip to: 5115
/* 5106 */    MCD::OPC_CheckPredicate, 3, 60, 9, 0, // Skip to: 7475
/* 5111 */    MCD::OPC_Decode, 196, 3, 37, // Opcode: FORNOT2
/* 5115 */    MCD::OPC_FilterValue, 119, 9, 0, 0, // Skip to: 5129
/* 5120 */    MCD::OPC_CheckPredicate, 3, 46, 9, 0, // Skip to: 7475
/* 5125 */    MCD::OPC_Decode, 197, 3, 36, // Opcode: FORNOT2S
/* 5129 */    MCD::OPC_FilterValue, 120, 16, 0, 0, // Skip to: 5150
/* 5134 */    MCD::OPC_CheckPredicate, 3, 32, 9, 0, // Skip to: 7475
/* 5139 */    MCD::OPC_CheckField, 14, 5, 0, 25, 9, 0, // Skip to: 7475
/* 5146 */    MCD::OPC_Decode, 228, 3, 34, // Opcode: FSRC2
/* 5150 */    MCD::OPC_FilterValue, 121, 16, 0, 0, // Skip to: 5171
/* 5155 */    MCD::OPC_CheckPredicate, 3, 11, 9, 0, // Skip to: 7475
/* 5160 */    MCD::OPC_CheckField, 14, 5, 0, 4, 9, 0, // Skip to: 7475
/* 5167 */    MCD::OPC_Decode, 229, 3, 33, // Opcode: FSRC2S
/* 5171 */    MCD::OPC_FilterValue, 122, 9, 0, 0, // Skip to: 5185
/* 5176 */    MCD::OPC_CheckPredicate, 3, 246, 8, 0, // Skip to: 7475
/* 5181 */    MCD::OPC_Decode, 194, 3, 37, // Opcode: FORNOT1
/* 5185 */    MCD::OPC_FilterValue, 123, 9, 0, 0, // Skip to: 5199
/* 5190 */    MCD::OPC_CheckPredicate, 3, 232, 8, 0, // Skip to: 7475
/* 5195 */    MCD::OPC_Decode, 195, 3, 36, // Opcode: FORNOT1S
/* 5199 */    MCD::OPC_FilterValue, 124, 9, 0, 0, // Skip to: 5213
/* 5204 */    MCD::OPC_CheckPredicate, 3, 218, 8, 0, // Skip to: 7475
/* 5209 */    MCD::OPC_Decode, 193, 3, 37, // Opcode: FOR
/* 5213 */    MCD::OPC_FilterValue, 125, 9, 0, 0, // Skip to: 5227
/* 5218 */    MCD::OPC_CheckPredicate, 3, 204, 8, 0, // Skip to: 7475
/* 5223 */    MCD::OPC_Decode, 198, 3, 36, // Opcode: FORS
/* 5227 */    MCD::OPC_FilterValue, 126, 23, 0, 0, // Skip to: 5255
/* 5232 */    MCD::OPC_CheckPredicate, 3, 190, 8, 0, // Skip to: 7475
/* 5237 */    MCD::OPC_CheckField, 14, 5, 0, 183, 8, 0, // Skip to: 7475
/* 5244 */    MCD::OPC_CheckField, 0, 5, 0, 176, 8, 0, // Skip to: 7475
/* 5251 */    MCD::OPC_Decode, 191, 3, 62, // Opcode: FONE
/* 5255 */    MCD::OPC_FilterValue, 127, 23, 0, 0, // Skip to: 5283
/* 5260 */    MCD::OPC_CheckPredicate, 3, 162, 8, 0, // Skip to: 7475
/* 5265 */    MCD::OPC_CheckField, 14, 5, 0, 155, 8, 0, // Skip to: 7475
/* 5272 */    MCD::OPC_CheckField, 0, 5, 0, 148, 8, 0, // Skip to: 7475
/* 5279 */    MCD::OPC_Decode, 192, 3, 63, // Opcode: FONES
/* 5283 */    MCD::OPC_FilterValue, 128, 1, 30, 0, 0, // Skip to: 5319
/* 5289 */    MCD::OPC_CheckPredicate, 3, 133, 8, 0, // Skip to: 7475
/* 5294 */    MCD::OPC_CheckField, 25, 5, 0, 126, 8, 0, // Skip to: 7475
/* 5301 */    MCD::OPC_CheckField, 14, 5, 0, 119, 8, 0, // Skip to: 7475
/* 5308 */    MCD::OPC_CheckField, 0, 5, 0, 112, 8, 0, // Skip to: 7475
/* 5315 */    MCD::OPC_Decode, 230, 4, 4, // Opcode: SHUTDOWN
/* 5319 */    MCD::OPC_FilterValue, 129, 1, 30, 0, 0, // Skip to: 5355
/* 5325 */    MCD::OPC_CheckPredicate, 4, 97, 8, 0, // Skip to: 7475
/* 5330 */    MCD::OPC_CheckField, 25, 5, 0, 90, 8, 0, // Skip to: 7475
/* 5337 */    MCD::OPC_CheckField, 14, 5, 0, 83, 8, 0, // Skip to: 7475
/* 5344 */    MCD::OPC_CheckField, 0, 5, 0, 76, 8, 0, // Skip to: 7475
/* 5351 */    MCD::OPC_Decode, 231, 4, 4, // Opcode: SIAM
/* 5355 */    MCD::OPC_FilterValue, 144, 2, 16, 0, 0, // Skip to: 5377
/* 5361 */    MCD::OPC_CheckPredicate, 2, 61, 8, 0, // Skip to: 7475
/* 5366 */    MCD::OPC_CheckField, 14, 5, 0, 54, 8, 0, // Skip to: 7475
/* 5373 */    MCD::OPC_Decode, 172, 4, 66, // Opcode: MOVDTOX
/* 5377 */    MCD::OPC_FilterValue, 145, 2, 16, 0, 0, // Skip to: 5399
/* 5383 */    MCD::OPC_CheckPredicate, 2, 39, 8, 0, // Skip to: 7475
/* 5388 */    MCD::OPC_CheckField, 14, 5, 0, 32, 8, 0, // Skip to: 7475
/* 5395 */    MCD::OPC_Decode, 180, 4, 66, // Opcode: MOVSTOUW
/* 5399 */    MCD::OPC_FilterValue, 147, 2, 16, 0, 0, // Skip to: 5421
/* 5405 */    MCD::OPC_CheckPredicate, 2, 17, 8, 0, // Skip to: 7475
/* 5410 */    MCD::OPC_CheckField, 14, 5, 0, 10, 8, 0, // Skip to: 7475
/* 5417 */    MCD::OPC_Decode, 179, 4, 66, // Opcode: MOVSTOSW
/* 5421 */    MCD::OPC_FilterValue, 149, 2, 9, 0, 0, // Skip to: 5436
/* 5427 */    MCD::OPC_CheckPredicate, 2, 251, 7, 0, // Skip to: 7475
/* 5432 */    MCD::OPC_Decode, 233, 5, 10, // Opcode: XMULX
/* 5436 */    MCD::OPC_FilterValue, 151, 2, 9, 0, 0, // Skip to: 5451
/* 5442 */    MCD::OPC_CheckPredicate, 2, 236, 7, 0, // Skip to: 7475
/* 5447 */    MCD::OPC_Decode, 234, 5, 10, // Opcode: XMULXHI
/* 5451 */    MCD::OPC_FilterValue, 152, 2, 16, 0, 0, // Skip to: 5473
/* 5457 */    MCD::OPC_CheckPredicate, 2, 221, 7, 0, // Skip to: 7475
/* 5462 */    MCD::OPC_CheckField, 14, 5, 0, 214, 7, 0, // Skip to: 7475
/* 5469 */    MCD::OPC_Decode, 184, 4, 67, // Opcode: MOVXTOD
/* 5473 */    MCD::OPC_FilterValue, 153, 2, 16, 0, 0, // Skip to: 5495
/* 5479 */    MCD::OPC_CheckPredicate, 2, 199, 7, 0, // Skip to: 7475
/* 5484 */    MCD::OPC_CheckField, 14, 5, 0, 192, 7, 0, // Skip to: 7475
/* 5491 */    MCD::OPC_Decode, 181, 4, 67, // Opcode: MOVWTOS
/* 5495 */    MCD::OPC_FilterValue, 209, 2, 9, 0, 0, // Skip to: 5510
/* 5501 */    MCD::OPC_CheckPredicate, 2, 177, 7, 0, // Skip to: 7475
/* 5506 */    MCD::OPC_Decode, 142, 3, 57, // Opcode: FLCMPS
/* 5510 */    MCD::OPC_FilterValue, 210, 2, 167, 7, 0, // Skip to: 7475
/* 5516 */    MCD::OPC_CheckPredicate, 2, 162, 7, 0, // Skip to: 7475
/* 5521 */    MCD::OPC_Decode, 141, 3, 57, // Opcode: FLCMPD
/* 5525 */    MCD::OPC_FilterValue, 56, 28, 0, 0, // Skip to: 5558
/* 5530 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5533 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5549
/* 5538 */    MCD::OPC_CheckField, 5, 8, 0, 138, 7, 0, // Skip to: 7475
/* 5545 */    MCD::OPC_Decode, 251, 3, 68, // Opcode: JMPLrr
/* 5549 */    MCD::OPC_FilterValue, 1, 129, 7, 0, // Skip to: 7475
/* 5554 */    MCD::OPC_Decode, 250, 3, 69, // Opcode: JMPLri
/* 5558 */    MCD::OPC_FilterValue, 57, 42, 0, 0, // Skip to: 5605
/* 5563 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5566 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 5589
/* 5571 */    MCD::OPC_CheckField, 25, 5, 0, 105, 7, 0, // Skip to: 7475
/* 5578 */    MCD::OPC_CheckField, 5, 8, 0, 98, 7, 0, // Skip to: 7475
/* 5585 */    MCD::OPC_Decode, 219, 4, 70, // Opcode: RETTrr
/* 5589 */    MCD::OPC_FilterValue, 1, 89, 7, 0, // Skip to: 7475
/* 5594 */    MCD::OPC_CheckField, 25, 5, 0, 82, 7, 0, // Skip to: 7475
/* 5601 */    MCD::OPC_Decode, 218, 4, 71, // Opcode: RETTri
/* 5605 */    MCD::OPC_FilterValue, 58, 119, 0, 0, // Skip to: 5729
/* 5610 */    MCD::OPC_ExtractField, 8, 6,  // Inst{13-8} ...
/* 5613 */    MCD::OPC_FilterValue, 16, 18, 0, 0, // Skip to: 5636
/* 5618 */    MCD::OPC_CheckField, 29, 1, 0, 58, 7, 0, // Skip to: 7475
/* 5625 */    MCD::OPC_CheckField, 5, 3, 0, 51, 7, 0, // Skip to: 7475
/* 5632 */    MCD::OPC_Decode, 197, 5, 72, // Opcode: TXCCrr
/* 5636 */    MCD::OPC_FilterValue, 32, 72, 0, 0, // Skip to: 5713
/* 5641 */    MCD::OPC_ExtractField, 0, 8,  // Inst{7-0} ...
/* 5644 */    MCD::OPC_FilterValue, 1, 18, 0, 0, // Skip to: 5667
/* 5649 */    MCD::OPC_CheckField, 25, 5, 8, 27, 7, 0, // Skip to: 7475
/* 5656 */    MCD::OPC_CheckField, 14, 5, 0, 20, 7, 0, // Skip to: 7475
/* 5663 */    MCD::OPC_Decode, 174, 5, 4, // Opcode: TA1
/* 5667 */    MCD::OPC_FilterValue, 3, 18, 0, 0, // Skip to: 5690
/* 5672 */    MCD::OPC_CheckField, 25, 5, 8, 4, 7, 0, // Skip to: 7475
/* 5679 */    MCD::OPC_CheckField, 14, 5, 0, 253, 6, 0, // Skip to: 7475
/* 5686 */    MCD::OPC_Decode, 175, 5, 4, // Opcode: TA3
/* 5690 */    MCD::OPC_FilterValue, 5, 244, 6, 0, // Skip to: 7475
/* 5695 */    MCD::OPC_CheckField, 25, 5, 8, 237, 6, 0, // Skip to: 7475
/* 5702 */    MCD::OPC_CheckField, 14, 5, 0, 230, 6, 0, // Skip to: 7475
/* 5709 */    MCD::OPC_Decode, 176, 5, 4, // Opcode: TA5
/* 5713 */    MCD::OPC_FilterValue, 48, 221, 6, 0, // Skip to: 7475
/* 5718 */    MCD::OPC_CheckField, 29, 1, 0, 214, 6, 0, // Skip to: 7475
/* 5725 */    MCD::OPC_Decode, 196, 5, 73, // Opcode: TXCCri
/* 5729 */    MCD::OPC_FilterValue, 59, 62, 0, 0, // Skip to: 5796
/* 5734 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5737 */    MCD::OPC_FilterValue, 0, 38, 0, 0, // Skip to: 5780
/* 5742 */    MCD::OPC_ExtractField, 5, 8,  // Inst{12-5} ...
/* 5745 */    MCD::OPC_FilterValue, 0, 189, 6, 0, // Skip to: 7475
/* 5750 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 5753 */    MCD::OPC_FilterValue, 0, 181, 6, 0, // Skip to: 7475
/* 5758 */    MCD::OPC_CheckField, 14, 5, 0, 11, 0, 0, // Skip to: 5776
/* 5765 */    MCD::OPC_CheckField, 0, 5, 0, 4, 0, 0, // Skip to: 5776
/* 5772 */    MCD::OPC_Decode, 143, 3, 4, // Opcode: FLUSH
/* 5776 */    MCD::OPC_Decode, 146, 3, 70, // Opcode: FLUSHrr
/* 5780 */    MCD::OPC_FilterValue, 1, 154, 6, 0, // Skip to: 7475
/* 5785 */    MCD::OPC_CheckField, 25, 5, 0, 147, 6, 0, // Skip to: 7475
/* 5792 */    MCD::OPC_Decode, 145, 3, 71, // Opcode: FLUSHri
/* 5796 */    MCD::OPC_FilterValue, 60, 28, 0, 0, // Skip to: 5829
/* 5801 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5804 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5820
/* 5809 */    MCD::OPC_CheckField, 5, 8, 0, 123, 6, 0, // Skip to: 7475
/* 5816 */    MCD::OPC_Decode, 221, 4, 8, // Opcode: SAVErr
/* 5820 */    MCD::OPC_FilterValue, 1, 114, 6, 0, // Skip to: 7475
/* 5825 */    MCD::OPC_Decode, 220, 4, 9, // Opcode: SAVEri
/* 5829 */    MCD::OPC_FilterValue, 61, 28, 0, 0, // Skip to: 5862
/* 5834 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5837 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5853
/* 5842 */    MCD::OPC_CheckField, 5, 8, 0, 90, 6, 0, // Skip to: 7475
/* 5849 */    MCD::OPC_Decode, 215, 4, 8, // Opcode: RESTORErr
/* 5853 */    MCD::OPC_FilterValue, 1, 81, 6, 0, // Skip to: 7475
/* 5858 */    MCD::OPC_Decode, 214, 4, 9, // Opcode: RESTOREri
/* 5862 */    MCD::OPC_FilterValue, 62, 28, 0, 0, // Skip to: 5895
/* 5867 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5870 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5886
/* 5875 */    MCD::OPC_CheckField, 5, 8, 0, 57, 6, 0, // Skip to: 7475
/* 5882 */    MCD::OPC_Decode, 205, 5, 8, // Opcode: UMACrr
/* 5886 */    MCD::OPC_FilterValue, 1, 48, 6, 0, // Skip to: 7475
/* 5891 */    MCD::OPC_Decode, 204, 5, 9, // Opcode: UMACri
/* 5895 */    MCD::OPC_FilterValue, 63, 39, 6, 0, // Skip to: 7475
/* 5900 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5903 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5919
/* 5908 */    MCD::OPC_CheckField, 5, 8, 0, 24, 6, 0, // Skip to: 7475
/* 5915 */    MCD::OPC_Decode, 238, 4, 8, // Opcode: SMACrr
/* 5919 */    MCD::OPC_FilterValue, 1, 15, 6, 0, // Skip to: 7475
/* 5924 */    MCD::OPC_Decode, 237, 4, 9, // Opcode: SMACri
/* 5928 */    MCD::OPC_FilterValue, 3, 6, 6, 0, // Skip to: 7475
/* 5933 */    MCD::OPC_ExtractField, 19, 6,  // Inst{24-19} ...
/* 5936 */    MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 5969
/* 5941 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5944 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5960
/* 5949 */    MCD::OPC_CheckField, 5, 8, 0, 239, 5, 0, // Skip to: 7475
/* 5956 */    MCD::OPC_Decode, 167, 4, 68, // Opcode: LDrr
/* 5960 */    MCD::OPC_FilterValue, 1, 230, 5, 0, // Skip to: 7475
/* 5965 */    MCD::OPC_Decode, 166, 4, 69, // Opcode: LDri
/* 5969 */    MCD::OPC_FilterValue, 1, 28, 0, 0, // Skip to: 6002
/* 5974 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5977 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5993
/* 5982 */    MCD::OPC_CheckField, 5, 8, 0, 206, 5, 0, // Skip to: 7475
/* 5989 */    MCD::OPC_Decode, 158, 4, 68, // Opcode: LDUBrr
/* 5993 */    MCD::OPC_FilterValue, 1, 197, 5, 0, // Skip to: 7475
/* 5998 */    MCD::OPC_Decode, 157, 4, 69, // Opcode: LDUBri
/* 6002 */    MCD::OPC_FilterValue, 2, 28, 0, 0, // Skip to: 6035
/* 6007 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6010 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6026
/* 6015 */    MCD::OPC_CheckField, 5, 8, 0, 173, 5, 0, // Skip to: 7475
/* 6022 */    MCD::OPC_Decode, 161, 4, 68, // Opcode: LDUHrr
/* 6026 */    MCD::OPC_FilterValue, 1, 164, 5, 0, // Skip to: 7475
/* 6031 */    MCD::OPC_Decode, 160, 4, 69, // Opcode: LDUHri
/* 6035 */    MCD::OPC_FilterValue, 3, 28, 0, 0, // Skip to: 6068
/* 6040 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6043 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6059
/* 6048 */    MCD::OPC_CheckField, 5, 8, 0, 140, 5, 0, // Skip to: 7475
/* 6055 */    MCD::OPC_Decode, 136, 4, 74, // Opcode: LDDrr
/* 6059 */    MCD::OPC_FilterValue, 1, 131, 5, 0, // Skip to: 7475
/* 6064 */    MCD::OPC_Decode, 135, 4, 75, // Opcode: LDDri
/* 6068 */    MCD::OPC_FilterValue, 4, 28, 0, 0, // Skip to: 6101
/* 6073 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6076 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6092
/* 6081 */    MCD::OPC_CheckField, 5, 8, 0, 107, 5, 0, // Skip to: 7475
/* 6088 */    MCD::OPC_Decode, 160, 5, 76, // Opcode: STrr
/* 6092 */    MCD::OPC_FilterValue, 1, 98, 5, 0, // Skip to: 7475
/* 6097 */    MCD::OPC_Decode, 159, 5, 77, // Opcode: STri
/* 6101 */    MCD::OPC_FilterValue, 5, 28, 0, 0, // Skip to: 6134
/* 6106 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6109 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6125
/* 6114 */    MCD::OPC_CheckField, 5, 8, 0, 74, 5, 0, // Skip to: 7475
/* 6121 */    MCD::OPC_Decode, 255, 4, 76, // Opcode: STBrr
/* 6125 */    MCD::OPC_FilterValue, 1, 65, 5, 0, // Skip to: 7475
/* 6130 */    MCD::OPC_Decode, 254, 4, 77, // Opcode: STBri
/* 6134 */    MCD::OPC_FilterValue, 6, 28, 0, 0, // Skip to: 6167
/* 6139 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6142 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6158
/* 6147 */    MCD::OPC_CheckField, 5, 8, 0, 41, 5, 0, // Skip to: 7475
/* 6154 */    MCD::OPC_Decode, 151, 5, 76, // Opcode: STHrr
/* 6158 */    MCD::OPC_FilterValue, 1, 32, 5, 0, // Skip to: 7475
/* 6163 */    MCD::OPC_Decode, 150, 5, 77, // Opcode: STHri
/* 6167 */    MCD::OPC_FilterValue, 7, 28, 0, 0, // Skip to: 6200
/* 6172 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6175 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6191
/* 6180 */    MCD::OPC_CheckField, 5, 8, 0, 8, 5, 0, // Skip to: 7475
/* 6187 */    MCD::OPC_Decode, 143, 5, 78, // Opcode: STDrr
/* 6191 */    MCD::OPC_FilterValue, 1, 255, 4, 0, // Skip to: 7475
/* 6196 */    MCD::OPC_Decode, 142, 5, 79, // Opcode: STDri
/* 6200 */    MCD::OPC_FilterValue, 8, 28, 0, 0, // Skip to: 6233
/* 6205 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6208 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6224
/* 6213 */    MCD::OPC_CheckField, 5, 8, 0, 231, 4, 0, // Skip to: 7475
/* 6220 */    MCD::OPC_Decode, 155, 4, 80, // Opcode: LDSWrr
/* 6224 */    MCD::OPC_FilterValue, 1, 222, 4, 0, // Skip to: 7475
/* 6229 */    MCD::OPC_Decode, 154, 4, 81, // Opcode: LDSWri
/* 6233 */    MCD::OPC_FilterValue, 9, 28, 0, 0, // Skip to: 6266
/* 6238 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6241 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6257
/* 6246 */    MCD::OPC_CheckField, 5, 8, 0, 198, 4, 0, // Skip to: 7475
/* 6253 */    MCD::OPC_Decode, 147, 4, 68, // Opcode: LDSBrr
/* 6257 */    MCD::OPC_FilterValue, 1, 189, 4, 0, // Skip to: 7475
/* 6262 */    MCD::OPC_Decode, 146, 4, 69, // Opcode: LDSBri
/* 6266 */    MCD::OPC_FilterValue, 10, 28, 0, 0, // Skip to: 6299
/* 6271 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6274 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6290
/* 6279 */    MCD::OPC_CheckField, 5, 8, 0, 165, 4, 0, // Skip to: 7475
/* 6286 */    MCD::OPC_Decode, 150, 4, 68, // Opcode: LDSHrr
/* 6290 */    MCD::OPC_FilterValue, 1, 156, 4, 0, // Skip to: 7475
/* 6295 */    MCD::OPC_Decode, 149, 4, 69, // Opcode: LDSHri
/* 6299 */    MCD::OPC_FilterValue, 11, 28, 0, 0, // Skip to: 6332
/* 6304 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6307 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6323
/* 6312 */    MCD::OPC_CheckField, 5, 8, 0, 132, 4, 0, // Skip to: 7475
/* 6319 */    MCD::OPC_Decode, 165, 4, 80, // Opcode: LDXrr
/* 6323 */    MCD::OPC_FilterValue, 1, 123, 4, 0, // Skip to: 7475
/* 6328 */    MCD::OPC_Decode, 164, 4, 81, // Opcode: LDXri
/* 6332 */    MCD::OPC_FilterValue, 13, 28, 0, 0, // Skip to: 6365
/* 6337 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6340 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6356
/* 6345 */    MCD::OPC_CheckField, 5, 8, 0, 99, 4, 0, // Skip to: 7475
/* 6352 */    MCD::OPC_Decode, 153, 4, 68, // Opcode: LDSTUBrr
/* 6356 */    MCD::OPC_FilterValue, 1, 90, 4, 0, // Skip to: 7475
/* 6361 */    MCD::OPC_Decode, 152, 4, 69, // Opcode: LDSTUBri
/* 6365 */    MCD::OPC_FilterValue, 14, 28, 0, 0, // Skip to: 6398
/* 6370 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6373 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6389
/* 6378 */    MCD::OPC_CheckField, 5, 8, 0, 66, 4, 0, // Skip to: 7475
/* 6385 */    MCD::OPC_Decode, 158, 5, 82, // Opcode: STXrr
/* 6389 */    MCD::OPC_FilterValue, 1, 57, 4, 0, // Skip to: 7475
/* 6394 */    MCD::OPC_Decode, 157, 5, 83, // Opcode: STXri
/* 6398 */    MCD::OPC_FilterValue, 15, 28, 0, 0, // Skip to: 6431
/* 6403 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6406 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6422
/* 6411 */    MCD::OPC_CheckField, 5, 8, 0, 33, 4, 0, // Skip to: 7475
/* 6418 */    MCD::OPC_Decode, 173, 5, 84, // Opcode: SWAPrr
/* 6422 */    MCD::OPC_FilterValue, 1, 24, 4, 0, // Skip to: 7475
/* 6427 */    MCD::OPC_Decode, 172, 5, 85, // Opcode: SWAPri
/* 6431 */    MCD::OPC_FilterValue, 16, 11, 0, 0, // Skip to: 6447
/* 6436 */    MCD::OPC_CheckField, 13, 1, 0, 8, 4, 0, // Skip to: 7475
/* 6443 */    MCD::OPC_Decode, 252, 3, 86, // Opcode: LDArr
/* 6447 */    MCD::OPC_FilterValue, 17, 11, 0, 0, // Skip to: 6463
/* 6452 */    MCD::OPC_CheckField, 13, 1, 0, 248, 3, 0, // Skip to: 7475
/* 6459 */    MCD::OPC_Decode, 156, 4, 86, // Opcode: LDUBArr
/* 6463 */    MCD::OPC_FilterValue, 18, 11, 0, 0, // Skip to: 6479
/* 6468 */    MCD::OPC_CheckField, 13, 1, 0, 232, 3, 0, // Skip to: 7475
/* 6475 */    MCD::OPC_Decode, 159, 4, 86, // Opcode: LDUHArr
/* 6479 */    MCD::OPC_FilterValue, 19, 11, 0, 0, // Skip to: 6495
/* 6484 */    MCD::OPC_CheckField, 13, 1, 0, 216, 3, 0, // Skip to: 7475
/* 6491 */    MCD::OPC_Decode, 129, 4, 87, // Opcode: LDDArr
/* 6495 */    MCD::OPC_FilterValue, 20, 11, 0, 0, // Skip to: 6511
/* 6500 */    MCD::OPC_CheckField, 13, 1, 0, 200, 3, 0, // Skip to: 7475
/* 6507 */    MCD::OPC_Decode, 251, 4, 88, // Opcode: STArr
/* 6511 */    MCD::OPC_FilterValue, 21, 11, 0, 0, // Skip to: 6527
/* 6516 */    MCD::OPC_CheckField, 13, 1, 0, 184, 3, 0, // Skip to: 7475
/* 6523 */    MCD::OPC_Decode, 253, 4, 88, // Opcode: STBArr
/* 6527 */    MCD::OPC_FilterValue, 22, 11, 0, 0, // Skip to: 6543
/* 6532 */    MCD::OPC_CheckField, 13, 1, 0, 168, 3, 0, // Skip to: 7475
/* 6539 */    MCD::OPC_Decode, 149, 5, 88, // Opcode: STHArr
/* 6543 */    MCD::OPC_FilterValue, 23, 11, 0, 0, // Skip to: 6559
/* 6548 */    MCD::OPC_CheckField, 13, 1, 0, 152, 3, 0, // Skip to: 7475
/* 6555 */    MCD::OPC_Decode, 132, 5, 89, // Opcode: STDArr
/* 6559 */    MCD::OPC_FilterValue, 25, 11, 0, 0, // Skip to: 6575
/* 6564 */    MCD::OPC_CheckField, 13, 1, 0, 136, 3, 0, // Skip to: 7475
/* 6571 */    MCD::OPC_Decode, 145, 4, 86, // Opcode: LDSBArr
/* 6575 */    MCD::OPC_FilterValue, 26, 11, 0, 0, // Skip to: 6591
/* 6580 */    MCD::OPC_CheckField, 13, 1, 0, 120, 3, 0, // Skip to: 7475
/* 6587 */    MCD::OPC_Decode, 148, 4, 86, // Opcode: LDSHArr
/* 6591 */    MCD::OPC_FilterValue, 29, 11, 0, 0, // Skip to: 6607
/* 6596 */    MCD::OPC_CheckField, 13, 1, 0, 104, 3, 0, // Skip to: 7475
/* 6603 */    MCD::OPC_Decode, 151, 4, 86, // Opcode: LDSTUBArr
/* 6607 */    MCD::OPC_FilterValue, 31, 11, 0, 0, // Skip to: 6623
/* 6612 */    MCD::OPC_CheckField, 13, 1, 0, 88, 3, 0, // Skip to: 7475
/* 6619 */    MCD::OPC_Decode, 171, 5, 90, // Opcode: SWAPArr
/* 6623 */    MCD::OPC_FilterValue, 32, 28, 0, 0, // Skip to: 6656
/* 6628 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6631 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6647
/* 6636 */    MCD::OPC_CheckField, 5, 8, 0, 64, 3, 0, // Skip to: 7475
/* 6643 */    MCD::OPC_Decode, 141, 4, 91, // Opcode: LDFrr
/* 6647 */    MCD::OPC_FilterValue, 1, 55, 3, 0, // Skip to: 7475
/* 6652 */    MCD::OPC_Decode, 140, 4, 92, // Opcode: LDFri
/* 6656 */    MCD::OPC_FilterValue, 33, 79, 0, 0, // Skip to: 6740
/* 6661 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6664 */    MCD::OPC_FilterValue, 0, 40, 0, 0, // Skip to: 6709
/* 6669 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 6672 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6688
/* 6677 */    MCD::OPC_CheckField, 5, 8, 0, 23, 3, 0, // Skip to: 7475
/* 6684 */    MCD::OPC_Decode, 139, 4, 70, // Opcode: LDFSRrr
/* 6688 */    MCD::OPC_FilterValue, 1, 14, 3, 0, // Skip to: 7475
/* 6693 */    MCD::OPC_CheckPredicate, 0, 9, 3, 0, // Skip to: 7475
/* 6698 */    MCD::OPC_CheckField, 5, 8, 0, 2, 3, 0, // Skip to: 7475
/* 6705 */    MCD::OPC_Decode, 163, 4, 70, // Opcode: LDXFSRrr
/* 6709 */    MCD::OPC_FilterValue, 1, 249, 2, 0, // Skip to: 7475
/* 6714 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 6717 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6726
/* 6722 */    MCD::OPC_Decode, 138, 4, 71, // Opcode: LDFSRri
/* 6726 */    MCD::OPC_FilterValue, 1, 232, 2, 0, // Skip to: 7475
/* 6731 */    MCD::OPC_CheckPredicate, 0, 227, 2, 0, // Skip to: 7475
/* 6736 */    MCD::OPC_Decode, 162, 4, 71, // Opcode: LDXFSRri
/* 6740 */    MCD::OPC_FilterValue, 34, 38, 0, 0, // Skip to: 6783
/* 6745 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6748 */    MCD::OPC_FilterValue, 0, 16, 0, 0, // Skip to: 6769
/* 6753 */    MCD::OPC_CheckPredicate, 0, 205, 2, 0, // Skip to: 7475
/* 6758 */    MCD::OPC_CheckField, 5, 8, 0, 198, 2, 0, // Skip to: 7475
/* 6765 */    MCD::OPC_Decode, 144, 4, 93, // Opcode: LDQFrr
/* 6769 */    MCD::OPC_FilterValue, 1, 189, 2, 0, // Skip to: 7475
/* 6774 */    MCD::OPC_CheckPredicate, 0, 184, 2, 0, // Skip to: 7475
/* 6779 */    MCD::OPC_Decode, 143, 4, 94, // Opcode: LDQFri
/* 6783 */    MCD::OPC_FilterValue, 35, 28, 0, 0, // Skip to: 6816
/* 6788 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6791 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6807
/* 6796 */    MCD::OPC_CheckField, 5, 8, 0, 160, 2, 0, // Skip to: 7475
/* 6803 */    MCD::OPC_Decode, 134, 4, 95, // Opcode: LDDFrr
/* 6807 */    MCD::OPC_FilterValue, 1, 151, 2, 0, // Skip to: 7475
/* 6812 */    MCD::OPC_Decode, 133, 4, 96, // Opcode: LDDFri
/* 6816 */    MCD::OPC_FilterValue, 36, 28, 0, 0, // Skip to: 6849
/* 6821 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6824 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6840
/* 6829 */    MCD::OPC_CheckField, 5, 8, 0, 127, 2, 0, // Skip to: 7475
/* 6836 */    MCD::OPC_Decode, 148, 5, 97, // Opcode: STFrr
/* 6840 */    MCD::OPC_FilterValue, 1, 118, 2, 0, // Skip to: 7475
/* 6845 */    MCD::OPC_Decode, 147, 5, 98, // Opcode: STFri
/* 6849 */    MCD::OPC_FilterValue, 37, 79, 0, 0, // Skip to: 6933
/* 6854 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6857 */    MCD::OPC_FilterValue, 0, 40, 0, 0, // Skip to: 6902
/* 6862 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 6865 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6881
/* 6870 */    MCD::OPC_CheckField, 5, 8, 0, 86, 2, 0, // Skip to: 7475
/* 6877 */    MCD::OPC_Decode, 146, 5, 70, // Opcode: STFSRrr
/* 6881 */    MCD::OPC_FilterValue, 1, 77, 2, 0, // Skip to: 7475
/* 6886 */    MCD::OPC_CheckPredicate, 0, 72, 2, 0, // Skip to: 7475
/* 6891 */    MCD::OPC_CheckField, 5, 8, 0, 65, 2, 0, // Skip to: 7475
/* 6898 */    MCD::OPC_Decode, 156, 5, 70, // Opcode: STXFSRrr
/* 6902 */    MCD::OPC_FilterValue, 1, 56, 2, 0, // Skip to: 7475
/* 6907 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 6910 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6919
/* 6915 */    MCD::OPC_Decode, 145, 5, 71, // Opcode: STFSRri
/* 6919 */    MCD::OPC_FilterValue, 1, 39, 2, 0, // Skip to: 7475
/* 6924 */    MCD::OPC_CheckPredicate, 0, 34, 2, 0, // Skip to: 7475
/* 6929 */    MCD::OPC_Decode, 155, 5, 71, // Opcode: STXFSRri
/* 6933 */    MCD::OPC_FilterValue, 38, 61, 0, 0, // Skip to: 6999
/* 6938 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6941 */    MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 6974
/* 6946 */    MCD::OPC_ExtractField, 5, 8,  // Inst{12-5} ...
/* 6949 */    MCD::OPC_FilterValue, 0, 9, 2, 0, // Skip to: 7475
/* 6954 */    MCD::OPC_CheckField, 25, 5, 0, 4, 0, 0, // Skip to: 6965
/* 6961 */    MCD::OPC_Decode, 139, 5, 70, // Opcode: STDFQrr
/* 6965 */    MCD::OPC_CheckPredicate, 0, 249, 1, 0, // Skip to: 7475
/* 6970 */    MCD::OPC_Decode, 154, 5, 99, // Opcode: STQFrr
/* 6974 */    MCD::OPC_FilterValue, 1, 240, 1, 0, // Skip to: 7475
/* 6979 */    MCD::OPC_CheckField, 25, 5, 0, 4, 0, 0, // Skip to: 6990
/* 6986 */    MCD::OPC_Decode, 138, 5, 71, // Opcode: STDFQri
/* 6990 */    MCD::OPC_CheckPredicate, 0, 224, 1, 0, // Skip to: 7475
/* 6995 */    MCD::OPC_Decode, 153, 5, 100, // Opcode: STQFri
/* 6999 */    MCD::OPC_FilterValue, 39, 28, 0, 0, // Skip to: 7032
/* 7004 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7007 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7023
/* 7012 */    MCD::OPC_CheckField, 5, 8, 0, 200, 1, 0, // Skip to: 7475
/* 7019 */    MCD::OPC_Decode, 141, 5, 101, // Opcode: STDFrr
/* 7023 */    MCD::OPC_FilterValue, 1, 191, 1, 0, // Skip to: 7475
/* 7028 */    MCD::OPC_Decode, 140, 5, 102, // Opcode: STDFri
/* 7032 */    MCD::OPC_FilterValue, 45, 38, 0, 0, // Skip to: 7075
/* 7037 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7040 */    MCD::OPC_FilterValue, 0, 16, 0, 0, // Skip to: 7061
/* 7045 */    MCD::OPC_CheckPredicate, 0, 169, 1, 0, // Skip to: 7475
/* 7050 */    MCD::OPC_CheckField, 5, 8, 0, 162, 1, 0, // Skip to: 7475
/* 7057 */    MCD::OPC_Decode, 205, 4, 103, // Opcode: PREFETCHr
/* 7061 */    MCD::OPC_FilterValue, 1, 153, 1, 0, // Skip to: 7475
/* 7066 */    MCD::OPC_CheckPredicate, 0, 148, 1, 0, // Skip to: 7475
/* 7071 */    MCD::OPC_Decode, 204, 4, 104, // Opcode: PREFETCHi
/* 7075 */    MCD::OPC_FilterValue, 48, 37, 0, 0, // Skip to: 7117
/* 7080 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7083 */    MCD::OPC_FilterValue, 0, 20, 0, 0, // Skip to: 7108
/* 7088 */    MCD::OPC_CheckField, 5, 8, 0, 4, 0, 0, // Skip to: 7099
/* 7095 */    MCD::OPC_Decode, 128, 4, 105, // Opcode: LDCrr
/* 7099 */    MCD::OPC_CheckPredicate, 0, 115, 1, 0, // Skip to: 7475
/* 7104 */    MCD::OPC_Decode, 137, 4, 106, // Opcode: LDFArr
/* 7108 */    MCD::OPC_FilterValue, 1, 106, 1, 0, // Skip to: 7475
/* 7113 */    MCD::OPC_Decode, 255, 3, 107, // Opcode: LDCri
/* 7117 */    MCD::OPC_FilterValue, 49, 42, 0, 0, // Skip to: 7164
/* 7122 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7125 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 7148
/* 7130 */    MCD::OPC_CheckField, 25, 5, 0, 82, 1, 0, // Skip to: 7475
/* 7137 */    MCD::OPC_CheckField, 5, 8, 0, 75, 1, 0, // Skip to: 7475
/* 7144 */    MCD::OPC_Decode, 254, 3, 70, // Opcode: LDCSRrr
/* 7148 */    MCD::OPC_FilterValue, 1, 66, 1, 0, // Skip to: 7475
/* 7153 */    MCD::OPC_CheckField, 25, 5, 0, 59, 1, 0, // Skip to: 7475
/* 7160 */    MCD::OPC_Decode, 253, 3, 71, // Opcode: LDCSRri
/* 7164 */    MCD::OPC_FilterValue, 50, 16, 0, 0, // Skip to: 7185
/* 7169 */    MCD::OPC_CheckPredicate, 0, 45, 1, 0, // Skip to: 7475
/* 7174 */    MCD::OPC_CheckField, 13, 1, 0, 38, 1, 0, // Skip to: 7475
/* 7181 */    MCD::OPC_Decode, 142, 4, 108, // Opcode: LDQFArr
/* 7185 */    MCD::OPC_FilterValue, 51, 37, 0, 0, // Skip to: 7227
/* 7190 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7193 */    MCD::OPC_FilterValue, 0, 20, 0, 0, // Skip to: 7218
/* 7198 */    MCD::OPC_CheckField, 5, 8, 0, 4, 0, 0, // Skip to: 7209
/* 7205 */    MCD::OPC_Decode, 131, 4, 109, // Opcode: LDDCrr
/* 7209 */    MCD::OPC_CheckPredicate, 0, 5, 1, 0, // Skip to: 7475
/* 7214 */    MCD::OPC_Decode, 132, 4, 110, // Opcode: LDDFArr
/* 7218 */    MCD::OPC_FilterValue, 1, 252, 0, 0, // Skip to: 7475
/* 7223 */    MCD::OPC_Decode, 130, 4, 111, // Opcode: LDDCri
/* 7227 */    MCD::OPC_FilterValue, 52, 37, 0, 0, // Skip to: 7269
/* 7232 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7235 */    MCD::OPC_FilterValue, 0, 20, 0, 0, // Skip to: 7260
/* 7240 */    MCD::OPC_CheckField, 5, 8, 0, 4, 0, 0, // Skip to: 7251
/* 7247 */    MCD::OPC_Decode, 131, 5, 112, // Opcode: STCrr
/* 7251 */    MCD::OPC_CheckPredicate, 0, 219, 0, 0, // Skip to: 7475
/* 7256 */    MCD::OPC_Decode, 144, 5, 113, // Opcode: STFArr
/* 7260 */    MCD::OPC_FilterValue, 1, 210, 0, 0, // Skip to: 7475
/* 7265 */    MCD::OPC_Decode, 130, 5, 114, // Opcode: STCri
/* 7269 */    MCD::OPC_FilterValue, 53, 42, 0, 0, // Skip to: 7316
/* 7274 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7277 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 7300
/* 7282 */    MCD::OPC_CheckField, 25, 5, 0, 186, 0, 0, // Skip to: 7475
/* 7289 */    MCD::OPC_CheckField, 5, 8, 0, 179, 0, 0, // Skip to: 7475
/* 7296 */    MCD::OPC_Decode, 129, 5, 70, // Opcode: STCSRrr
/* 7300 */    MCD::OPC_FilterValue, 1, 170, 0, 0, // Skip to: 7475
/* 7305 */    MCD::OPC_CheckField, 25, 5, 0, 163, 0, 0, // Skip to: 7475
/* 7312 */    MCD::OPC_Decode, 128, 5, 71, // Opcode: STCSRri
/* 7316 */    MCD::OPC_FilterValue, 54, 51, 0, 0, // Skip to: 7372
/* 7321 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7324 */    MCD::OPC_FilterValue, 0, 27, 0, 0, // Skip to: 7356
/* 7329 */    MCD::OPC_CheckField, 25, 5, 0, 11, 0, 0, // Skip to: 7347
/* 7336 */    MCD::OPC_CheckField, 5, 8, 0, 4, 0, 0, // Skip to: 7347
/* 7343 */    MCD::OPC_Decode, 134, 5, 70, // Opcode: STDCQrr
/* 7347 */    MCD::OPC_CheckPredicate, 0, 123, 0, 0, // Skip to: 7475
/* 7352 */    MCD::OPC_Decode, 152, 5, 115, // Opcode: STQFArr
/* 7356 */    MCD::OPC_FilterValue, 1, 114, 0, 0, // Skip to: 7475
/* 7361 */    MCD::OPC_CheckField, 25, 5, 0, 107, 0, 0, // Skip to: 7475
/* 7368 */    MCD::OPC_Decode, 133, 5, 71, // Opcode: STDCQri
/* 7372 */    MCD::OPC_FilterValue, 55, 37, 0, 0, // Skip to: 7414
/* 7377 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7380 */    MCD::OPC_FilterValue, 0, 20, 0, 0, // Skip to: 7405
/* 7385 */    MCD::OPC_CheckField, 5, 8, 0, 4, 0, 0, // Skip to: 7396
/* 7392 */    MCD::OPC_Decode, 136, 5, 116, // Opcode: STDCrr
/* 7396 */    MCD::OPC_CheckPredicate, 0, 74, 0, 0, // Skip to: 7475
/* 7401 */    MCD::OPC_Decode, 137, 5, 117, // Opcode: STDFArr
/* 7405 */    MCD::OPC_FilterValue, 1, 65, 0, 0, // Skip to: 7475
/* 7410 */    MCD::OPC_Decode, 135, 5, 118, // Opcode: STDCri
/* 7414 */    MCD::OPC_FilterValue, 60, 39, 0, 0, // Skip to: 7458
/* 7419 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7422 */    MCD::OPC_FilterValue, 0, 48, 0, 0, // Skip to: 7475
/* 7427 */    MCD::OPC_ExtractField, 5, 8,  // Inst{12-5} ...
/* 7430 */    MCD::OPC_FilterValue, 10, 4, 0, 0, // Skip to: 7439
/* 7435 */    MCD::OPC_Decode, 198, 2, 119, // Opcode: CASAasi10
/* 7439 */    MCD::OPC_FilterValue, 128, 1, 9, 0, 0, // Skip to: 7454
/* 7445 */    MCD::OPC_CheckPredicate, 0, 4, 0, 0, // Skip to: 7454
/* 7450 */    MCD::OPC_Decode, 201, 2, 119, // Opcode: CASrr
/* 7454 */    MCD::OPC_Decode, 199, 2, 120, // Opcode: CASArr
/* 7458 */    MCD::OPC_FilterValue, 62, 12, 0, 0, // Skip to: 7475
/* 7463 */    MCD::OPC_CheckField, 5, 9, 128, 1, 4, 0, 0, // Skip to: 7475
/* 7471 */    MCD::OPC_Decode, 200, 2, 121, // Opcode: CASXrr
/* 7475 */    MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableSparcV832[] = {
/* 0 */       MCD::OPC_ExtractField, 8, 6,  // Inst{13-8} ...
/* 3 */       MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 33
/* 8 */       MCD::OPC_CheckField, 29, 3, 4, 41, 0, 0, // Skip to: 56
/* 15 */      MCD::OPC_CheckField, 19, 6, 58, 34, 0, 0, // Skip to: 56
/* 22 */      MCD::OPC_CheckField, 5, 3, 0, 27, 0, 0, // Skip to: 56
/* 29 */      MCD::OPC_Decode, 191, 5, 72, // Opcode: TRAPrr
/* 33 */      MCD::OPC_FilterValue, 32, 18, 0, 0, // Skip to: 56
/* 38 */      MCD::OPC_CheckField, 29, 3, 4, 11, 0, 0, // Skip to: 56
/* 45 */      MCD::OPC_CheckField, 19, 6, 58, 4, 0, 0, // Skip to: 56
/* 52 */      MCD::OPC_Decode, 190, 5, 73, // Opcode: TRAPri
/* 56 */      MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableSparcV932[] = {
/* 0 */       MCD::OPC_ExtractField, 8, 6,  // Inst{13-8} ...
/* 3 */       MCD::OPC_FilterValue, 0, 30, 0, 0, // Skip to: 38
/* 8 */       MCD::OPC_CheckPredicate, 0, 53, 0, 0, // Skip to: 66
/* 13 */      MCD::OPC_CheckField, 29, 3, 4, 46, 0, 0, // Skip to: 66
/* 20 */      MCD::OPC_CheckField, 19, 6, 58, 39, 0, 0, // Skip to: 66
/* 27 */      MCD::OPC_CheckField, 5, 3, 0, 32, 0, 0, // Skip to: 66
/* 34 */      MCD::OPC_Decode, 184, 5, 72, // Opcode: TICCrr
/* 38 */      MCD::OPC_FilterValue, 32, 23, 0, 0, // Skip to: 66
/* 43 */      MCD::OPC_CheckPredicate, 0, 18, 0, 0, // Skip to: 66
/* 48 */      MCD::OPC_CheckField, 29, 3, 4, 11, 0, 0, // Skip to: 66
/* 55 */      MCD::OPC_CheckField, 19, 6, 58, 4, 0, 0, // Skip to: 66
/* 62 */      MCD::OPC_Decode, 183, 5, 73, // Opcode: TICCri
/* 66 */      MCD::OPC_Fail,
  0
};

static bool checkDecoderPredicate(unsigned Idx, const FeatureBitset &Bits) {
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    return (Bits[Sparc::FeatureV9]);
  case 1:
    return (Bits[Sparc::FeaturePWRPSR]);
  case 2:
    return (Bits[Sparc::FeatureVIS3]);
  case 3:
    return (Bits[Sparc::FeatureVIS]);
  case 4:
    return (Bits[Sparc::FeatureVIS2]);
  }
}

template <typename InsnType>
static DecodeStatus decodeToMCInst(DecodeStatus S, unsigned Idx, InsnType insn, MCInst &MI,
                                   uint64_t Address, const MCDisassembler *Decoder, bool &DecodeComplete) {
  DecodeComplete = true;
  using TmpType = std::conditional_t<std::is_integral<InsnType>::value, InsnType, uint64_t>;
  TmpType tmp;
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    tmp = fieldFromInstruction(insn, 0, 22);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 1:
    tmp = fieldFromInstruction(insn, 0, 19);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 2:
    tmp = fieldFromInstruction(insn, 0, 22);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 3:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 14), 0, 14);
    insertBits(tmp, fieldFromInstruction(insn, 20, 2), 14, 2);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 4:
    return S;
  case 5:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 22);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 6:
    tmp = fieldFromInstruction(insn, 0, 19);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 20, 2);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 7:
    tmp = fieldFromInstruction(insn, 0, 30);
    if (!Check(S, DecodeCall(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 8:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 9:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 10:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 11:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 12:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 13:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 14:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 15:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 6);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 16:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 6);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 17:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 18:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeASRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 19:
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 20:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 21:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 22:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 23:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 11);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 24:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 11);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 25:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 26:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 27:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 10);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 28:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeASRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 29:
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 30:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeASRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 31:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodePRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 32:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodePRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 33:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 34:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 35:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 36:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 37:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 38:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 39:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 40:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 41:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 42:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 43:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 44:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 45:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 46:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 47:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 48:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 49:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 50:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 51:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 52:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 53:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 54:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 55:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 56:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 57:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 58:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 59:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 60:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 61:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 62:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 63:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 64:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 65:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 66:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 67:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 68:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 69:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 70:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 71:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 72:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 73:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 74:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 75:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 76:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 77:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 78:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 79:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 80:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 81:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 82:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 83:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 84:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 85:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 86:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 87:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 88:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 89:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 90:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 91:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 92:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 93:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 94:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 95:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 96:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 97:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 98:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 99:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 100:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 101:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 102:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 103:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 104:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 105:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 106:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 107:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 108:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 109:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 110:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 111:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 112:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 113:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 114:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 115:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 116:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 117:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 118:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 119:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 120:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 121:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  }
}

template <typename InsnType>
static DecodeStatus decodeInstruction(const uint8_t DecodeTable[], MCInst &MI,
                                      InsnType insn, uint64_t Address,
                                      const MCDisassembler *DisAsm,
                                      const MCSubtargetInfo &STI) {
  const FeatureBitset &Bits = STI.getFeatureBits();

  const uint8_t *Ptr = DecodeTable;
  uint64_t CurFieldValue = 0;
  DecodeStatus S = MCDisassembler::Success;
  while (true) {
    ptrdiff_t Loc = Ptr - DecodeTable;
    switch (*Ptr) {
    default:
      errs() << Loc << ": Unexpected decode table opcode!\n";
      return MCDisassembler::Fail;
    case MCD::OPC_ExtractField: {
      unsigned Start = *++Ptr;
      unsigned Len = *++Ptr;
      ++Ptr;
      CurFieldValue = fieldFromInstruction(insn, Start, Len);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_ExtractField(" << Start << ", "
                   << Len << "): " << CurFieldValue << "\n");
      break;
    }
    case MCD::OPC_FilterValue: {
      // Decode the field value.
      unsigned Len;
      uint64_t Val = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // Perform the filter operation.
      if (Val != CurFieldValue)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_FilterValue(" << Val << ", " << NumToSkip
                   << "): " << ((Val != CurFieldValue) ? "FAIL:" : "PASS:")
                   << " continuing at " << (Ptr - DecodeTable) << "\n");

      break;
    }
    case MCD::OPC_CheckField: {
      unsigned Start = *++Ptr;
      unsigned Len = *++Ptr;
      uint64_t FieldValue = fieldFromInstruction(insn, Start, Len);
      // Decode the field value.
      unsigned PtrLen = 0;
      uint64_t ExpectedValue = decodeULEB128(++Ptr, &PtrLen);
      Ptr += PtrLen;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // If the actual and expected values don't match, skip.
      if (ExpectedValue != FieldValue)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckField(" << Start << ", "
                   << Len << ", " << ExpectedValue << ", " << NumToSkip
                   << "): FieldValue = " << FieldValue << ", ExpectedValue = "
                   << ExpectedValue << ": "
                   << ((ExpectedValue == FieldValue) ? "PASS\n" : "FAIL\n"));
      break;
    }
    case MCD::OPC_CheckPredicate: {
      unsigned Len;
      // Decode the Predicate Index value.
      unsigned PIdx = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;
      // Check the predicate.
      bool Pred;
      if (!(Pred = checkDecoderPredicate(PIdx, Bits)))
        Ptr += NumToSkip;
      (void)Pred;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckPredicate(" << PIdx << "): "
            << (Pred ? "PASS\n" : "FAIL\n"));

      break;
    }
    case MCD::OPC_Decode: {
      unsigned Len;
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      unsigned DecodeIdx = decodeULEB128(Ptr, &Len);
      Ptr += Len;

      MI.clear();
      MI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, MI, Address, DisAsm, DecodeComplete);
      assert(DecodeComplete);

      LLVM_DEBUG(dbgs() << Loc << ": OPC_Decode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": "
                   << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
      return S;
    }
    case MCD::OPC_TryDecode: {
      unsigned Len;
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      unsigned DecodeIdx = decodeULEB128(Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // Perform the decode operation.
      MCInst TmpMI;
      TmpMI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, TmpMI, Address, DisAsm, DecodeComplete);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_TryDecode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": ");

      if (DecodeComplete) {
        // Decoding complete.
        LLVM_DEBUG(dbgs() << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
        MI = TmpMI;
        return S;
      } else {
        assert(S == MCDisassembler::Fail);
        // If the decoding was incomplete, skip.
        Ptr += NumToSkip;
        LLVM_DEBUG(dbgs() << "FAIL: continuing at " << (Ptr - DecodeTable) << "\n");
        // Reset decode status. This also drops a SoftFail status that could be
        // set before the decode attempt.
        S = MCDisassembler::Success;
      }
      break;
    }
    case MCD::OPC_SoftFail: {
      // Decode the mask values.
      unsigned Len;
      uint64_t PositiveMask = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      uint64_t NegativeMask = decodeULEB128(Ptr, &Len);
      Ptr += Len;
      bool Fail = (insn & PositiveMask) != 0 || (~insn & NegativeMask) != 0;
      if (Fail)
        S = MCDisassembler::SoftFail;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_SoftFail: " << (Fail ? "FAIL\n" : "PASS\n"));
      break;
    }
    case MCD::OPC_Fail: {
      LLVM_DEBUG(dbgs() << Loc << ": OPC_Fail\n");
      return MCDisassembler::Fail;
    }
    }
  }
  llvm_unreachable("bogosity detected in disassembler state machine!");
}


} // end namespace llvm
